diff -rNci gcc-2.7.2/config/i386/i386.c gcc-2.7.2p/config/i386/i386.c
*** gcc-2.7.2/config/i386/i386.c	Sun Oct 22 11:13:21 1995
--- gcc-2.7.2p/config/i386/i386.c	Tue Jan 23 09:34:59 1996
***************
*** 1653,3245 ****
    else
      output_asm_insn ("ret", xops);
  }
- 
  
! /* GO_IF_LEGITIMATE_ADDRESS recognizes an RTL expression
!    that is a valid memory address for an instruction.
!    The MODE argument is the machine mode for the MEM expression
!    that wants to use this address.
! 
!    On x86, legitimate addresses are:
! 	base				movl (base),reg
! 	displacement			movl disp,reg
! 	base + displacement		movl disp(base),reg
! 	index + base			movl (base,index),reg
! 	(index + base) + displacement	movl disp(base,index),reg
! 	index*scale			movl (,index,scale),reg
! 	index*scale + disp		movl disp(,index,scale),reg
! 	index*scale + base 		movl (base,index,scale),reg
! 	(index*scale + base) + disp	movl disp(base,index,scale),reg
! 
! 	In each case, scale can be 1, 2, 4, 8.  */
! 
! /* This is exactly the same as print_operand_addr, except that
!    it recognizes addresses instead of printing them.
! 
!    It only recognizes address in canonical form.  LEGITIMIZE_ADDRESS should
!    convert common non-canonical forms to canonical form so that they will
!    be recognized.  */
! 
! #define ADDR_INVALID(msg,insn)						\
! do {									\
!   if (TARGET_DEBUG_ADDR)						\
!     {									\
!       fprintf (stderr, msg);						\
!       debug_rtx (insn);							\
!     }									\
! } while (0)
  
! int
! legitimate_address_p (mode, addr, strict)
!      enum machine_mode mode;
!      register rtx addr;
!      int strict;
  {
!   rtx base  = NULL_RTX;
!   rtx indx  = NULL_RTX;
!   rtx scale = NULL_RTX;
!   rtx disp  = NULL_RTX;
! 
!   if (TARGET_DEBUG_ADDR)
!     {
!       fprintf (stderr,
! 	       "\n==========\nGO_IF_LEGITIMATE_ADDRESS, mode = %s, strict = %d\n",
! 	       GET_MODE_NAME (mode), strict);
! 
!       debug_rtx (addr);
!     }
! 
!   if (GET_CODE (addr) == REG || GET_CODE (addr) == SUBREG)
!       base = addr;				/* base reg */
  
!   else if (GET_CODE (addr) == PLUS)
      {
!       rtx op0 = XEXP (addr, 0);
!       rtx op1 = XEXP (addr, 1);
!       enum rtx_code code0 = GET_CODE (op0);
!       enum rtx_code code1 = GET_CODE (op1);
  
!       if (code0 == REG || code0 == SUBREG)
  	{
! 	  if (code1 == REG || code1 == SUBREG)
! 	    {
! 	      indx = op0;			/* index + base */
! 	      base = op1;
! 	    }
! 
! 	  else
! 	    {
! 	      base = op0;			/* base + displacement */
! 	      disp = op1;
! 	    }
! 	}
! 
!       else if (code0 == MULT)
! 	{
! 	  indx  = XEXP (op0, 0);
! 	  scale = XEXP (op0, 1);
! 
! 	  if (code1 == REG || code1 == SUBREG)
! 	    base = op1;				/* index*scale + base */
! 
! 	  else
! 	    disp = op1;				/* index*scale + disp */
! 	}
! 
!       else if (code0 == PLUS && GET_CODE (XEXP (op0, 0)) == MULT)
! 	{
! 	  indx  = XEXP (XEXP (op0, 0), 0);	/* index*scale + base + disp */
! 	  scale = XEXP (XEXP (op0, 0), 1);
! 	  base  = XEXP (op0, 1);
! 	  disp  = op1;
! 	}
! 
!       else if (code0 == PLUS)
! 	{
! 	  indx = XEXP (op0, 0);			/* index + base + disp */
! 	  base = XEXP (op0, 1);
! 	  disp = op1;
  	}
  
        else
! 	{
! 	  ADDR_INVALID ("PLUS subcode is not valid.\n", op0);
! 	  return FALSE;
! 	}
!     }
  
!   else if (GET_CODE (addr) == MULT)
!     {
!       indx  = XEXP (addr, 0);			/* index*scale */
!       scale = XEXP (addr, 1);
!     }
  
!   else
!     disp = addr;				/* displacement */
  
!   /* Allow arg pointer and stack pointer as index if there is not scaling */
!   if (base && indx && !scale
!       && (indx == arg_pointer_rtx || indx == stack_pointer_rtx))
!     {
!       rtx tmp = base;
!       base = indx;
!       indx = tmp;
!     }
  
!   /* Validate base register */
!   /* Don't allow SUBREG's here, it can lead to spill failures when the base
!      is one word out of a two word structure, which is represented internally
!      as a DImode int.  */
!   if (base)
!     {
!       if (GET_CODE (base) != REG)
! 	{
! 	  ADDR_INVALID ("Base is not a register.\n", base);
! 	  return FALSE;
! 	}
  
!       if ((strict && !REG_OK_FOR_BASE_STRICT_P (base))
! 	  || (!strict && !REG_OK_FOR_BASE_NONSTRICT_P (base)))
  	{
! 	  ADDR_INVALID ("Base is not valid.\n", base);
! 	  return FALSE;
  	}
!     }
  
!   /* Validate index register */
!   /* Don't allow SUBREG's here, it can lead to spill failures when the index
!      is one word out of a two word structure, which is represented internally
!      as a DImode int.  */
!   if (indx)
!     {
!       if (GET_CODE (indx) != REG)
  	{
! 	  ADDR_INVALID ("Index is not a register.\n", indx);
! 	  return FALSE;
  	}
! 
!       if ((strict && !REG_OK_FOR_INDEX_STRICT_P (indx))
! 	  || (!strict && !REG_OK_FOR_INDEX_NONSTRICT_P (indx)))
  	{
! 	  ADDR_INVALID ("Index is not valid.\n", indx);
! 	  return FALSE;
  	}
!     }
!   else if (scale)
!     abort ();					/* scale w/o index invalid */
! 
!   /* Validate scale factor */
!   if (scale)
!     {
!       HOST_WIDE_INT value;
  
!       if (GET_CODE (scale) != CONST_INT)
! 	{
! 	  ADDR_INVALID ("Scale is not valid.\n", scale);
! 	  return FALSE;
! 	}
  
!       value = INTVAL (scale);
!       if (value != 1 && value != 2 && value != 4 && value != 8)
! 	{
! 	  ADDR_INVALID ("Scale is not a good multiplier.\n", scale);
! 	  return FALSE;
! 	}
      }
  
!   /* Validate displacement */
!   if (disp)
      {
!       if (!CONSTANT_ADDRESS_P (disp))
  	{
! 	  ADDR_INVALID ("Displacement is not valid.\n", disp);
! 	  return FALSE;
! 	}
  
!       if (GET_CODE (disp) == CONST_DOUBLE)
! 	{
! 	  ADDR_INVALID ("Displacement is a const_double.\n", disp);
! 	  return FALSE;
! 	}
  
!       if (flag_pic && SYMBOLIC_CONST (disp) && base != pic_offset_table_rtx
! 	  && (indx != pic_offset_table_rtx || scale != NULL_RTX))
! 	{
! 	  ADDR_INVALID ("Displacement is an invalid pic reference.\n", disp);
! 	  return FALSE;
! 	}
  
!       if (HALF_PIC_P () && HALF_PIC_ADDRESS_P (disp)
! 	  && (base != NULL_RTX || indx != NULL_RTX))
! 	{
! 	  ADDR_INVALID ("Displacement is an invalid half-pic reference.\n", disp);
! 	  return FALSE;
! 	}
!     }
  
!   if (TARGET_DEBUG_ADDR)
!     fprintf (stderr, "Address is valid.\n");
  
!   /* Everything looks valid, return true */
!   return TRUE;
! }
  
! 
! /* Return a legitimate reference for ORIG (an address) using the
!    register REG.  If REG is 0, a new pseudo is generated.
  
!    There are three types of references that must be handled:
  
!    1. Global data references must load the address from the GOT, via
!       the PIC reg.  An insn is emitted to do this load, and the reg is
!       returned.
  
!    2. Static data references must compute the address as an offset
!       from the GOT, whose base is in the PIC reg.  An insn is emitted to
!       compute the address into a reg, and the reg is returned.  Static
!       data objects have SYMBOL_REF_FLAG set to differentiate them from
!       global data objects.
  
!    3. Constant pool addresses must be handled special.  They are
!       considered legitimate addresses, but only if not used with regs.
!       When printed, the output routines know to print the reference with the
!       PIC reg, even though the PIC reg doesn't appear in the RTL.
  
!    GO_IF_LEGITIMATE_ADDRESS rejects symbolic references unless the PIC
!    reg also appears in the address (except for constant pool references,
!    noted above).
  
!    "switch" statements also require special handling when generating
!    PIC code.  See comments by the `casesi' insn in i386.md for details.  */
  
! rtx
! legitimize_pic_address (orig, reg)
!      rtx orig;
!      rtx reg;
! {
!   rtx addr = orig;
!   rtx new = orig;
  
!   if (GET_CODE (addr) == SYMBOL_REF || GET_CODE (addr) == LABEL_REF)
!     {
!       if (GET_CODE (addr) == SYMBOL_REF && CONSTANT_POOL_ADDRESS_P (addr))
! 	reg = new = orig;
!       else
! 	{
! 	  if (reg == 0)
! 	    reg = gen_reg_rtx (Pmode);
  
! 	  if ((GET_CODE (addr) == SYMBOL_REF && SYMBOL_REF_FLAG (addr))
! 	      || GET_CODE (addr) == LABEL_REF)
! 	    new = gen_rtx (PLUS, Pmode, pic_offset_table_rtx, orig);
! 	  else
! 	    new = gen_rtx (MEM, Pmode,
! 			   gen_rtx (PLUS, Pmode,
! 				    pic_offset_table_rtx, orig));
  
! 	  emit_move_insn (reg, new);
! 	}
!       current_function_uses_pic_offset_table = 1;
!       return reg;
!     }
!   else if (GET_CODE (addr) == CONST || GET_CODE (addr) == PLUS)
!     {
!       rtx base;
  
!       if (GET_CODE (addr) == CONST)
! 	{
! 	  addr = XEXP (addr, 0);
! 	  if (GET_CODE (addr) != PLUS)
! 	    abort ();
! 	}
  
!       if (XEXP (addr, 0) == pic_offset_table_rtx)
! 	return orig;
  
!       if (reg == 0)
! 	reg = gen_reg_rtx (Pmode);
! 
!       base = legitimize_pic_address (XEXP (addr, 0), reg);
!       addr = legitimize_pic_address (XEXP (addr, 1),
! 				     base == reg ? NULL_RTX : reg);
! 
!       if (GET_CODE (addr) == CONST_INT)
! 	return plus_constant (base, INTVAL (addr));
! 
!       if (GET_CODE (addr) == PLUS && CONSTANT_P (XEXP (addr, 1)))
  	{
! 	  base = gen_rtx (PLUS, Pmode, base, XEXP (addr, 0));
! 	  addr = XEXP (addr, 1);
  	}
! 	return gen_rtx (PLUS, Pmode, base, addr);
      }
-   return new;
  }
  
! 
! /* Emit insns to move operands[1] into operands[0].  */
  
  void
! emit_pic_move (operands, mode)
!      rtx *operands;
!      enum machine_mode mode;
! {
!   rtx temp = reload_in_progress ? operands[0] : gen_reg_rtx (Pmode);
! 
!   if (GET_CODE (operands[0]) == MEM && SYMBOLIC_CONST (operands[1]))
!     operands[1] = (rtx) force_reg (SImode, operands[1]);
!   else
!     operands[1] = legitimize_pic_address (operands[1], temp);
! }
! 
! 
! /* Try machine-dependent ways of modifying an illegitimate address
!    to be legitimate.  If we find one, return the new, valid address.
!    This macro is used in only one place: `memory_address' in explow.c.
! 
!    OLDX is the address as it was before break_out_memory_refs was called.
!    In some cases it is useful to look at this to decide what needs to be done.
! 
!    MODE and WIN are passed so that this macro can use
!    GO_IF_LEGITIMATE_ADDRESS.
! 
!    It is always safe for this macro to do nothing.  It exists to recognize
!    opportunities to optimize the output.
! 
!    For the 80386, we handle X+REG by loading X into a register R and
!    using R+REG.  R will go in a general reg and indexing will be used.
!    However, if REG is a broken-out memory address or multiplication,
!    nothing needs to be done because REG can certainly go in a general reg.
! 
!    When -fpic is used, special handling is needed for symbolic references.
!    See comments by legitimize_pic_address in i386.c for details.  */
! 
! rtx
! legitimize_address (x, oldx, mode)
!      register rtx x;
!      register rtx oldx;
!      enum machine_mode mode;
  {
!   int changed = 0;
!   unsigned log;
! 
!   if (TARGET_DEBUG_ADDR)
!     {
!       fprintf (stderr, "\n==========\nLEGITIMIZE_ADDRESS, mode = %s\n", GET_MODE_NAME (mode));
!       debug_rtx (x);
!     }
! 
!   if (flag_pic && SYMBOLIC_CONST (x))
!     return legitimize_pic_address (x, 0);
  
!   /* Canonicalize shifts by 0, 1, 2, 3 into multiply */
!   if (GET_CODE (x) == ASHIFT
!       && GET_CODE (XEXP (x, 1)) == CONST_INT
!       && (log = (unsigned)exact_log2 (INTVAL (XEXP (x, 1)))) < 4)
      {
!       changed = 1;
!       x = gen_rtx (MULT, Pmode,
! 		   force_reg (Pmode, XEXP (x, 0)),
! 		   GEN_INT (1 << log));
!     }
  
!   if (GET_CODE (x) == PLUS)
!     {
!       /* Canonicalize shifts by 0, 1, 2, 3 into multiply */
!       if (GET_CODE (XEXP (x, 0)) == ASHIFT
! 	  && GET_CODE (XEXP (XEXP (x, 0), 1)) == CONST_INT
! 	  && (log = (unsigned)exact_log2 (INTVAL (XEXP (XEXP (x, 0), 1)))) < 4)
  	{
! 	  changed = 1;
! 	  XEXP (x, 0) = gen_rtx (MULT, Pmode,
! 				 force_reg (Pmode, XEXP (XEXP (x, 0), 0)),
! 				 GEN_INT (1 << log));
  	}
! 
!       if (GET_CODE (XEXP (x, 1)) == ASHIFT
! 	  && GET_CODE (XEXP (XEXP (x, 1), 1)) == CONST_INT
! 	  && (log = (unsigned)exact_log2 (INTVAL (XEXP (XEXP (x, 1), 1)))) < 4)
  	{
! 	  changed = 1;
! 	  XEXP (x, 1) = gen_rtx (MULT, Pmode,
! 				 force_reg (Pmode, XEXP (XEXP (x, 1), 0)),
! 				 GEN_INT (1 << log));
  	}
! 
!       /* Put multiply first if it isn't already */
!       if (GET_CODE (XEXP (x, 1)) == MULT)
  	{
! 	  rtx tmp = XEXP (x, 0);
! 	  XEXP (x, 0) = XEXP (x, 1);
! 	  XEXP (x, 1) = tmp;
! 	  changed = 1;
  	}
! 
!       /* Canonicalize (plus (mult (reg) (const)) (plus (reg) (const)))
! 	 into (plus (plus (mult (reg) (const)) (reg)) (const)).  This can be
! 	 created by virtual register instantiation, register elimination, and
! 	 similar optimizations.  */
!       if (GET_CODE (XEXP (x, 0)) == MULT && GET_CODE (XEXP (x, 1)) == PLUS)
  	{
! 	  changed = 1;
! 	  x = gen_rtx (PLUS, Pmode,
! 		       gen_rtx (PLUS, Pmode, XEXP (x, 0), XEXP (XEXP (x, 1), 0)),
! 		       XEXP (XEXP (x, 1), 1));
  	}
  
!       /* Canonicalize (plus (plus (mult (reg) (const)) (plus (reg) (const))) const)
! 	 into (plus (plus (mult (reg) (const)) (reg)) (const)).  */
!       else if (GET_CODE (x) == PLUS && GET_CODE (XEXP (x, 0)) == PLUS
! 	       && GET_CODE (XEXP (XEXP (x, 0), 0)) == MULT
! 	       && GET_CODE (XEXP (XEXP (x, 0), 1)) == PLUS
! 	       && CONSTANT_P (XEXP (x, 1)))
  	{
! 	  rtx constant, other;
  
! 	  if (GET_CODE (XEXP (x, 1)) == CONST_INT)
! 	    {
! 	      constant = XEXP (x, 1);
! 	      other = XEXP (XEXP (XEXP (x, 0), 1), 1);
! 	    }
! 	  else if (GET_CODE (XEXP (XEXP (XEXP (x, 0), 1), 1)) == CONST_INT)
  	    {
! 	      constant = XEXP (XEXP (XEXP (x, 0), 1), 1);
! 	      other = XEXP (x, 1);
  	    }
- 	  else
- 	    constant = 0;
  
! 	  if (constant)
  	    {
! 	      changed = 1;
! 	      x = gen_rtx (PLUS, Pmode,
! 			   gen_rtx (PLUS, Pmode, XEXP (XEXP (x, 0), 0),
! 				    XEXP (XEXP (XEXP (x, 0), 1), 0)),
! 			   plus_constant (other, INTVAL (constant)));
  	    }
- 	}
- 
-       if (changed && legitimate_address_p (mode, x, FALSE))
- 	return x;
  
!       if (GET_CODE (XEXP (x, 0)) == MULT)
! 	{
! 	  changed = 1;
! 	  XEXP (x, 0) = force_operand (XEXP (x, 0), 0);
! 	}
  
!       if (GET_CODE (XEXP (x, 1)) == MULT)
! 	{
! 	  changed = 1;
! 	  XEXP (x, 1) = force_operand (XEXP (x, 1), 0);
! 	}
  
!       if (changed
! 	  && GET_CODE (XEXP (x, 1)) == REG
! 	  && GET_CODE (XEXP (x, 0)) == REG)
! 	return x;
  
!       if (flag_pic && SYMBOLIC_CONST (XEXP (x, 1)))
! 	{
! 	  changed = 1;
! 	  x = legitimize_pic_address (x, 0);
  	}
  
!       if (changed && legitimate_address_p (mode, x, FALSE))
! 	return x;
! 
!       if (GET_CODE (XEXP (x, 0)) == REG)
! 	{
! 	  register rtx temp = gen_reg_rtx (Pmode);
! 	  register rtx val  = force_operand (XEXP (x, 1), temp);
! 	  if (val != temp)
! 	    emit_move_insn (temp, val);
! 
! 	  XEXP (x, 1) = temp;
! 	  return x;
! 	}
  
!       else if (GET_CODE (XEXP (x, 1)) == REG)
  	{
! 	  register rtx temp = gen_reg_rtx (Pmode);
! 	  register rtx val  = force_operand (XEXP (x, 0), temp);
! 	  if (val != temp)
! 	    emit_move_insn (temp, val);
! 
! 	  XEXP (x, 0) = temp;
! 	  return x;
  	}
      }
- 
-   return x;
  }
- 
  
! /* Print an integer constant expression in assembler syntax.  Addition
!    and subtraction are the only arithmetic that may appear in these
!    expressions.  FILE is the stdio stream to write to, X is the rtx, and
!    CODE is the operand print code from the output string.  */
  
! static void
! output_pic_addr_const (file, x, code)
!      FILE *file;
!      rtx x;
!      int code;
! {
!   char buf[256];
  
!   switch (GET_CODE (x))
      {
!     case PC:
!       if (flag_pic)
! 	putc ('.', file);
!       else
! 	abort ();
!       break;
! 
!     case SYMBOL_REF:
!     case LABEL_REF:
!       if (GET_CODE (x) == SYMBOL_REF)
! 	assemble_name (file, XSTR (x, 0));
!       else
  	{
! 	  ASM_GENERATE_INTERNAL_LABEL (buf, "L",
! 				       CODE_LABEL_NUMBER (XEXP (x, 0)));
! 	  assemble_name (asm_out_file, buf);
  	}
  
!       if (GET_CODE (x) == SYMBOL_REF && CONSTANT_POOL_ADDRESS_P (x))
! 	fprintf (file, "@GOTOFF(%%ebx)");
!       else if (code == 'P')
! 	fprintf (file, "@PLT");
!       else if (GET_CODE (x) == LABEL_REF)
! 	fprintf (file, "@GOTOFF");
!       else if (! SYMBOL_REF_FLAG (x))
! 	fprintf (file, "@GOT");
!       else
! 	fprintf (file, "@GOTOFF");
! 
!       break;
! 
!     case CODE_LABEL:
!       ASM_GENERATE_INTERNAL_LABEL (buf, "L", CODE_LABEL_NUMBER (x));
!       assemble_name (asm_out_file, buf);
!       break;
! 
!     case CONST_INT:
!       fprintf (file, "%d", INTVAL (x));
!       break;
! 
!     case CONST:
!       /* This used to output parentheses around the expression,
! 	 but that does not work on the 386 (either ATT or BSD assembler).  */
!       output_pic_addr_const (file, XEXP (x, 0), code);
!       break;
  
!     case CONST_DOUBLE:
!       if (GET_MODE (x) == VOIDmode)
  	{
! 	  /* We can use %d if the number is <32 bits and positive.  */
! 	  if (CONST_DOUBLE_HIGH (x) || CONST_DOUBLE_LOW (x) < 0)
! 	    fprintf (file, "0x%x%08x",
! 		     CONST_DOUBLE_HIGH (x), CONST_DOUBLE_LOW (x));
  	  else
! 	    fprintf (file, "%d", CONST_DOUBLE_LOW (x));
  	}
!       else
! 	/* We can't handle floating point constants;
! 	   PRINT_OPERAND must handle them.  */
! 	output_operand_lossage ("floating constant misused");
!       break;
  
!     case PLUS:
!       /* Some assemblers need integer constants to appear last (eg masm).  */
!       if (GET_CODE (XEXP (x, 0)) == CONST_INT)
  	{
! 	  output_pic_addr_const (file, XEXP (x, 1), code);
! 	  if (INTVAL (XEXP (x, 0)) >= 0)
! 	    fprintf (file, "+");
! 	  output_pic_addr_const (file, XEXP (x, 0), code);
  	}
!       else
  	{
! 	  output_pic_addr_const (file, XEXP (x, 0), code);
! 	  if (INTVAL (XEXP (x, 1)) >= 0)
! 	    fprintf (file, "+");
! 	  output_pic_addr_const (file, XEXP (x, 1), code);
  	}
!       break;
  
      case MINUS:
!       output_pic_addr_const (file, XEXP (x, 0), code);
!       fprintf (file, "-");
!       output_pic_addr_const (file, XEXP (x, 1), code);
!       break;
  
      default:
!       output_operand_lossage ("invalid expression as operand");
      }
  }
- 
- /* Meaning of CODE:
-    f -- float insn (print a CONST_DOUBLE as a float rather than in hex).
-    D,L,W,B,Q,S -- print the opcode suffix for specified size of operand.
-    R -- print the prefix for register names.
-    z -- print the opcode suffix for the size of the current operand.
-    * -- print a star (in certain assembler syntax)
-    w -- print the operand as if it's a "word" (HImode) even if it isn't.
-    c -- don't print special prefixes before constant operands.
-    J -- print the appropriate jump operand.
- */
  
! void
! print_operand (file, x, code)
!      FILE *file;
!      rtx x;
!      int code;
  {
!   if (code)
      {
!       switch (code)
! 	{
! 	case '*':
! 	  if (USE_STAR)
! 	    putc ('*', file);
! 	  return;
  
! 	case 'L':
! 	  PUT_OP_SIZE (code, 'l', file);
! 	  return;
  
! 	case 'W':
! 	  PUT_OP_SIZE (code, 'w', file);
! 	  return;
  
! 	case 'B':
! 	  PUT_OP_SIZE (code, 'b', file);
! 	  return;
  
! 	case 'Q':
! 	  PUT_OP_SIZE (code, 'l', file);
! 	  return;
! 
! 	case 'S':
! 	  PUT_OP_SIZE (code, 's', file);
! 	  return;
  
! 	case 'T':
! 	  PUT_OP_SIZE (code, 't', file);
! 	  return;
  
! 	case 'z':
! 	  /* 387 opcodes don't get size suffixes if the operands are
! 	     registers. */
  
! 	  if (STACK_REG_P (x))
! 	    return;
  
! 	  /* this is the size of op from size of operand */
! 	  switch (GET_MODE_SIZE (GET_MODE (x)))
! 	    {
! 	    case 1:
! 	      PUT_OP_SIZE ('B', 'b', file);
! 	      return;
  
! 	    case 2:
! 	      PUT_OP_SIZE ('W', 'w', file);
! 	      return;
  
! 	    case 4:
! 	      if (GET_MODE (x) == SFmode)
! 		{
! 		  PUT_OP_SIZE ('S', 's', file);
! 		  return;
! 		}
! 	      else
! 		PUT_OP_SIZE ('L', 'l', file);
! 	      return;
  
! 	    case 12:
! 		  PUT_OP_SIZE ('T', 't', file);
! 		  return;
  
! 	    case 8:
! 	      if (GET_MODE_CLASS (GET_MODE (x)) == MODE_INT)
! 		{
! #ifdef GAS_MNEMONICS
! 		  PUT_OP_SIZE ('Q', 'q', file);
! 		  return;
! #else
! 		  PUT_OP_SIZE ('Q', 'l', file);	/* Fall through */
! #endif
! 		}
  
! 	      PUT_OP_SIZE ('Q', 'l', file);
! 	      return;
! 	    }
  
! 	case 'b':
! 	case 'w':
! 	case 'k':
! 	case 'h':
! 	case 'y':
! 	case 'P':
! 	  break;
  
! 	case 'J':
! 	  switch (GET_CODE (x))
! 	    {
! 	      /* These conditions are appropriate for testing the result
! 		 of an arithmetic operation, not for a compare operation.
! 	         Cases GE, LT assume CC_NO_OVERFLOW true. All cases assume
! 		 CC_Z_IN_NOT_C false and not floating point.  */
! 	    case NE:  fputs ("jne", file); return;
! 	    case EQ:  fputs ("je",  file); return;
! 	    case GE:  fputs ("jns", file); return;
! 	    case LT:  fputs ("js",  file); return;
! 	    case GEU: fputs ("jmp", file); return;
! 	    case GTU: fputs ("jne",  file); return;
! 	    case LEU: fputs ("je", file); return;
! 	    case LTU: fputs ("#branch never",  file); return;
  
! 	    /* no matching branches for GT nor LE */
! 	    }
! 	  abort ();
  
! 	default:
! 	  {
! 	    char str[50];
  
! 	    sprintf (str, "invalid operand code `%c'", code);
! 	    output_operand_lossage (str);
! 	  }
! 	}
!     }
!   if (GET_CODE (x) == REG)
!     {
!       PRINT_REG (x, code, file);
!     }
!   else if (GET_CODE (x) == MEM)
!     {
!       PRINT_PTR (x, file);
!       if (CONSTANT_ADDRESS_P (XEXP (x, 0)))
! 	{
! 	  if (flag_pic)
! 	    output_pic_addr_const (file, XEXP (x, 0), code);
! 	  else
! 	    output_addr_const (file, XEXP (x, 0));
! 	}
!       else
! 	output_address (XEXP (x, 0));
!     }
!   else if (GET_CODE (x) == CONST_DOUBLE && GET_MODE (x) == SFmode)
!     {
!       REAL_VALUE_TYPE r; long l;
!       REAL_VALUE_FROM_CONST_DOUBLE (r, x);
!       REAL_VALUE_TO_TARGET_SINGLE (r, l);
!       PRINT_IMMED_PREFIX (file);
!       fprintf (file, "0x%x", l);
!     }
!  /* These float cases don't actually occur as immediate operands. */
!  else if (GET_CODE (x) == CONST_DOUBLE && GET_MODE (x) == DFmode)
!     {
!       REAL_VALUE_TYPE r; char dstr[30];
!       REAL_VALUE_FROM_CONST_DOUBLE (r, x);
!       REAL_VALUE_TO_DECIMAL (r, "%.22e", dstr);
!       fprintf (file, "%s", dstr);
!     }
!   else if (GET_CODE (x) == CONST_DOUBLE && GET_MODE (x) == XFmode)
!     {
!       REAL_VALUE_TYPE r; char dstr[30];
!       REAL_VALUE_FROM_CONST_DOUBLE (r, x);
!       REAL_VALUE_TO_DECIMAL (r, "%.22e", dstr);
!       fprintf (file, "%s", dstr);
!     }
!   else 
      {
!       if (code != 'P')
  	{
! 	  if (GET_CODE (x) == CONST_INT || GET_CODE (x) == CONST_DOUBLE)
! 	    PRINT_IMMED_PREFIX (file);
! 	  else if (GET_CODE (x) == CONST || GET_CODE (x) == SYMBOL_REF
! 		   || GET_CODE (x) == LABEL_REF)
! 	    PRINT_OFFSET_PREFIX (file);
  	}
-       if (flag_pic)
- 	output_pic_addr_const (file, x, code);
-       else
- 	output_addr_const (file, x);
-     }
- }
- 
- /* Print a memory operand whose address is ADDR.  */
- 
- void
- print_operand_address (file, addr)
-      FILE *file;
-      register rtx addr;
- {
-   register rtx reg1, reg2, breg, ireg;
-   rtx offset;
  
!   switch (GET_CODE (addr))
!     {
!     case REG:
!       ADDR_BEG (file);
!       fprintf (file, "%se", RP);
!       fputs (hi_reg_name[REGNO (addr)], file);
!       ADDR_END (file);
!       break;
  
!     case PLUS:
!       reg1 = 0;
!       reg2 = 0;
!       ireg = 0;
!       breg = 0;
!       offset = 0;
!       if (CONSTANT_ADDRESS_P (XEXP (addr, 0)))
  	{
! 	  offset = XEXP (addr, 0);
! 	  addr = XEXP (addr, 1);
  	}
!       else if (CONSTANT_ADDRESS_P (XEXP (addr, 1)))
  	{
! 	  offset = XEXP (addr, 1);
! 	  addr = XEXP (addr, 0);
  	}
!       if (GET_CODE (addr) != PLUS) ;
!       else if (GET_CODE (XEXP (addr, 0)) == MULT)
! 	{
! 	  reg1 = XEXP (addr, 0);
! 	  addr = XEXP (addr, 1);
! 	}
!       else if (GET_CODE (XEXP (addr, 1)) == MULT)
! 	{
! 	  reg1 = XEXP (addr, 1);
! 	  addr = XEXP (addr, 0);
! 	}
!       else if (GET_CODE (XEXP (addr, 0)) == REG)
! 	{
! 	  reg1 = XEXP (addr, 0);
! 	  addr = XEXP (addr, 1);
! 	}
!       else if (GET_CODE (XEXP (addr, 1)) == REG)
! 	{
! 	  reg1 = XEXP (addr, 1);
! 	  addr = XEXP (addr, 0);
! 	}
!       if (GET_CODE (addr) == REG || GET_CODE (addr) == MULT)
! 	{
! 	  if (reg1 == 0) reg1 = addr;
! 	  else reg2 = addr;
! 	  addr = 0;
! 	}
!       if (offset != 0)
  	{
! 	  if (addr != 0) abort ();
! 	  addr = offset;
  	}
!       if ((reg1 && GET_CODE (reg1) == MULT)
! 	  || (reg2 != 0 && REGNO_OK_FOR_BASE_P (REGNO (reg2))))
  	{
! 	  breg = reg2;
! 	  ireg = reg1;
  	}
!       else if (reg1 != 0 && REGNO_OK_FOR_BASE_P (REGNO (reg1)))
  	{
! 	  breg = reg1;
! 	  ireg = reg2;
  	}
  
!       if (ireg != 0 || breg != 0)
! 	{
! 	  int scale = 1;
  
! 	  if (addr != 0)
! 	    {
! 	      if (flag_pic)
! 		output_pic_addr_const (file, addr, 0);
  
! 	      else if (GET_CODE (addr) == LABEL_REF)
! 		output_asm_label (addr);
  
! 	      else
! 		output_addr_const (file, addr);
! 	    }
  
!   	  if (ireg != 0 && GET_CODE (ireg) == MULT)
! 	    {
! 	      scale = INTVAL (XEXP (ireg, 1));
! 	      ireg = XEXP (ireg, 0);
! 	    }
  
! 	  /* The stack pointer can only appear as a base register,
! 	     never an index register, so exchange the regs if it is wrong. */
  
! 	  if (scale == 1 && ireg && REGNO (ireg) == STACK_POINTER_REGNUM)
! 	    {
! 	      rtx tmp;
  
! 	      tmp = breg;
! 	      breg = ireg;
! 	      ireg = tmp;
! 	    }
  
! 	  /* output breg+ireg*scale */
! 	  PRINT_B_I_S (breg, ireg, scale, file);
! 	  break;
! 	}
  
!     case MULT:
!       {
! 	int scale;
! 	if (GET_CODE (XEXP (addr, 0)) == CONST_INT)
! 	  {
! 	    scale = INTVAL (XEXP (addr, 0));
! 	    ireg = XEXP (addr, 1);
! 	  }
! 	else
! 	  {
! 	    scale = INTVAL (XEXP (addr, 1));
! 	    ireg = XEXP (addr, 0);
! 	  }
! 	output_addr_const (file, const0_rtx);
! 	PRINT_B_I_S ((rtx) 0, ireg, scale, file);
!       }
!       break;
  
!     default:
!       if (GET_CODE (addr) == CONST_INT
! 	  && INTVAL (addr) < 0x8000
! 	  && INTVAL (addr) >= -0x8000)
! 	fprintf (file, "%d", INTVAL (addr));
        else
! 	{
! 	  if (flag_pic)
! 	    output_pic_addr_const (file, addr, 0);
! 	  else
! 	    output_addr_const (file, addr);
! 	}
      }
  }
  
! /* Set the cc_status for the results of an insn whose pattern is EXP.
!    On the 80386, we assume that only test and compare insns, as well
!    as SI, HI, & DI mode ADD, SUB, NEG, AND, IOR, XOR, ASHIFT,
!    ASHIFTRT, and LSHIFTRT instructions set the condition codes usefully.
!    Also, we assume that jumps, moves and sCOND don't affect the condition
!    codes.  All else clobbers the condition codes, by assumption.
  
!    We assume that ALL integer add, minus, etc. instructions effect the
!    condition codes.  This MUST be consistent with i386.md.
  
!    We don't record any float test or compare - the redundant test &
!    compare check in final.c does not handle stack-like regs correctly. */
  
! void
! notice_update_cc (exp)
!      rtx exp;
! {
!   if (GET_CODE (exp) == SET)
      {
!       /* Jumps do not alter the cc's.  */
!       if (SET_DEST (exp) == pc_rtx)
! 	return;
!       /* Moving register or memory into a register:
! 	 it doesn't alter the cc's, but it might invalidate
! 	 the RTX's which we remember the cc's came from.
! 	 (Note that moving a constant 0 or 1 MAY set the cc's).  */
!       if (REG_P (SET_DEST (exp))
! 	  && (REG_P (SET_SRC (exp)) || GET_CODE (SET_SRC (exp)) == MEM
! 	      || GET_RTX_CLASS (GET_CODE (SET_SRC (exp))) == '<'))
! 	{
! 	  if (cc_status.value1
! 	      && reg_overlap_mentioned_p (SET_DEST (exp), cc_status.value1))
! 	    cc_status.value1 = 0;
! 	  if (cc_status.value2
! 	      && reg_overlap_mentioned_p (SET_DEST (exp), cc_status.value2))
! 	    cc_status.value2 = 0;
! 	  return;
! 	}
!       /* Moving register into memory doesn't alter the cc's.
! 	 It may invalidate the RTX's which we remember the cc's came from.  */
!       if (GET_CODE (SET_DEST (exp)) == MEM
! 	  && (REG_P (SET_SRC (exp))
! 	      || GET_RTX_CLASS (GET_CODE (SET_SRC (exp))) == '<'))
! 	{
! 	  if (cc_status.value1 && GET_CODE (cc_status.value1) == MEM)
! 	    cc_status.value1 = 0;
! 	  if (cc_status.value2 && GET_CODE (cc_status.value2) == MEM)
! 	    cc_status.value2 = 0;
! 	  return;
! 	}
!       /* Function calls clobber the cc's.  */
!       else if (GET_CODE (SET_SRC (exp)) == CALL)
! 	{
! 	  CC_STATUS_INIT;
! 	  return;
! 	}
!       /* Tests and compares set the cc's in predictable ways.  */
!       else if (SET_DEST (exp) == cc0_rtx)
! 	{
! 	  CC_STATUS_INIT;
! 	  cc_status.value1 = SET_SRC (exp);
! 	  return;
! 	}
!       /* Certain instructions effect the condition codes. */
!       else if (GET_MODE (SET_SRC (exp)) == SImode
! 	       || GET_MODE (SET_SRC (exp)) == HImode
! 	       || GET_MODE (SET_SRC (exp)) == QImode)
! 	switch (GET_CODE (SET_SRC (exp)))
! 	  {
! 	  case ASHIFTRT: case LSHIFTRT:
! 	  case ASHIFT:
! 	    /* Shifts on the 386 don't set the condition codes if the
! 	       shift count is zero. */
! 	    if (GET_CODE (XEXP (SET_SRC (exp), 1)) != CONST_INT)
! 	      {
! 		CC_STATUS_INIT;
! 		break;
! 	      }
! 	    /* We assume that the CONST_INT is non-zero (this rtx would
! 	       have been deleted if it were zero. */
  
! 	  case PLUS: case MINUS: case NEG:
! 	  case AND: case IOR: case XOR:
! 	    cc_status.flags = CC_NO_OVERFLOW;
! 	    cc_status.value1 = SET_SRC (exp);
! 	    cc_status.value2 = SET_DEST (exp);
! 	    break;
  
! 	  default:
! 	    CC_STATUS_INIT;
! 	  }
!       else
! 	{
! 	  CC_STATUS_INIT;
! 	}
      }
!   else if (GET_CODE (exp) == PARALLEL
! 	   && GET_CODE (XVECEXP (exp, 0, 0)) == SET)
      {
!       if (SET_DEST (XVECEXP (exp, 0, 0)) == pc_rtx)
! 	return;
!       if (SET_DEST (XVECEXP (exp, 0, 0)) == cc0_rtx)
! 	{
! 	  CC_STATUS_INIT;
! 	  if (stack_regs_mentioned_p (SET_SRC (XVECEXP (exp, 0, 0))))
! 	    cc_status.flags |= CC_IN_80387;
! 	  else
! 	    cc_status.value1 = SET_SRC (XVECEXP (exp, 0, 0));
! 	  return;
! 	}
!       CC_STATUS_INIT;
      }
    else
      {
!       CC_STATUS_INIT;
      }
  }
- 
- /* Split one or more DImode RTL references into pairs of SImode
-    references.  The RTL can be REG, offsettable MEM, integer constant, or
-    CONST_DOUBLE.  "operands" is a pointer to an array of DImode RTL to
-    split and "num" is its length.  lo_half and hi_half are output arrays
-    that parallel "operands". */
  
  void
! split_di (operands, num, lo_half, hi_half)
!      rtx operands[];
!      int num;
!      rtx lo_half[], hi_half[];
  {
!   while (num--)
!     {
!       if (GET_CODE (operands[num]) == REG)
! 	{
! 	  lo_half[num] = gen_rtx (REG, SImode, REGNO (operands[num]));
! 	  hi_half[num] = gen_rtx (REG, SImode, REGNO (operands[num]) + 1);
! 	}
!       else if (CONSTANT_P (operands[num]))
! 	{
! 	  split_double (operands[num], &lo_half[num], &hi_half[num]);
! 	}
!       else if (offsettable_memref_p (operands[num]))
! 	{
! 	  lo_half[num] = operands[num];
! 	  hi_half[num] = adj_offsettable_operand (operands[num], 4);
! 	}
!       else
! 	abort();
!     }
  }
- 
- /* Return 1 if this is a valid binary operation on a 387.
-    OP is the expression matched, and MODE is its mode. */
  
! int
! binary_387_op (op, mode)
!     register rtx op;
!     enum machine_mode mode;
  {
!   if (mode != VOIDmode && mode != GET_MODE (op))
!     return 0;
  
!   switch (GET_CODE (op))
!     {
!     case PLUS:
!     case MINUS:
!     case MULT:
!     case DIV:
!       return GET_MODE_CLASS (GET_MODE (op)) == MODE_FLOAT;
  
!     default:
!       return 0;
!     }
  }
  
! 
! /* Return 1 if this is a valid shift or rotate operation on a 386.
!    OP is the expression matched, and MODE is its mode. */
  
! int
! shift_op (op, mode)
!     register rtx op;
!     enum machine_mode mode;
  {
!   rtx operand = XEXP (op, 0);
  
!   if (mode != VOIDmode && mode != GET_MODE (op))
!     return 0;
  
-   if (GET_MODE (operand) != GET_MODE (op)
-       || GET_MODE_CLASS (GET_MODE (op)) != MODE_INT)
-     return 0;
  
!   return (GET_CODE (op) == ASHIFT
! 	  || GET_CODE (op) == ASHIFTRT
! 	  || GET_CODE (op) == LSHIFTRT
! 	  || GET_CODE (op) == ROTATE
! 	  || GET_CODE (op) == ROTATERT);
  }
  
! /* Return 1 if OP is COMPARE rtx with mode VOIDmode.
!    MODE is not used.  */
! 
! int
! VOIDmode_compare_op (op, mode)
      register rtx op;
      enum machine_mode mode;
  {
!   return GET_CODE (op) == COMPARE && GET_MODE (op) == VOIDmode;
  }
- 
- /* Output code to perform a 387 binary operation in INSN, one of PLUS,
-    MINUS, MULT or DIV.  OPERANDS are the insn operands, where operands[3]
-    is the expression of the binary operation.  The output may either be
-    emitted here, or returned to the caller, like all output_* functions.
  
!    There is no guarantee that the operands are the same mode, as they
!    might be within FLOAT or FLOAT_EXTEND expressions. */
  
! char *
! output_387_binary_op (insn, operands)
!      rtx insn;
!      rtx *operands;
  {
!   rtx temp;
!   char *base_op;
!   static char buf[100];
  
!   switch (GET_CODE (operands[3]))
      {
!     case PLUS:
!       if (GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_INT
! 	  || GET_MODE_CLASS (GET_MODE (operands[2])) == MODE_INT)
! 	base_op = "fiadd";
!       else
! 	base_op = "fadd";
!       break;
  
!     case MINUS:
!       if (GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_INT
! 	  || GET_MODE_CLASS (GET_MODE (operands[2])) == MODE_INT)
! 	base_op = "fisub";
!       else
! 	base_op = "fsub";
        break;
  
!     case MULT:
!       if (GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_INT
! 	  || GET_MODE_CLASS (GET_MODE (operands[2])) == MODE_INT)
! 	base_op = "fimul";
!       else
! 	base_op = "fmul";
!       break;
  
!     case DIV:
!       if (GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_INT
! 	  || GET_MODE_CLASS (GET_MODE (operands[2])) == MODE_INT)
! 	base_op = "fidiv";
!       else
! 	base_op = "fdiv";
!       break;
  
!     default:
!       abort ();
      }
! 
!   strcpy (buf, base_op);
! 
!   switch (GET_CODE (operands[3]))
      {
!     case MULT:
!     case PLUS:
!       if (REG_P (operands[2]) && REGNO (operands[0]) == REGNO (operands[2]))
  	{
! 	  temp = operands[2];
! 	  operands[2] = operands[1];
! 	  operands[1] = temp;
  	}
! 
!       if (GET_CODE (operands[2]) == MEM)
! 	return strcat (buf, AS1 (%z2,%2));
! 
!       if (NON_STACK_REG_P (operands[1]))
  	{
! 	  output_op_from_reg (operands[1], strcat (buf, AS1 (%z0,%1)));
! 	  RET;
  	}
!       else if (NON_STACK_REG_P (operands[2]))
  	{
! 	  output_op_from_reg (operands[2], strcat (buf, AS1 (%z0,%1)));
! 	  RET;
  	}
- 
-       if (find_regno_note (insn, REG_DEAD, REGNO (operands[2])))
- 	return strcat (buf, AS2 (p,%2,%0));
- 
-       if (STACK_TOP_P (operands[0]))
- 	return strcat (buf, AS2C (%y2,%0));
        else
- 	return strcat (buf, AS2C (%2,%0));
- 
-     case MINUS:
-     case DIV:
-       if (GET_CODE (operands[1]) == MEM)
- 	return strcat (buf, AS1 (r%z1,%1));
- 
-       if (GET_CODE (operands[2]) == MEM)
- 	return strcat (buf, AS1 (%z2,%2));
- 
-       if (NON_STACK_REG_P (operands[1]))
  	{
! 	  output_op_from_reg (operands[1], strcat (buf, AS1 (r%z0,%1)));
! 	  RET;
  	}
!       else if (NON_STACK_REG_P (operands[2]))
  	{
! 	  output_op_from_reg (operands[2], strcat (buf, AS1 (%z0,%1)));
! 	  RET;
  	}
! 
!       if (! STACK_REG_P (operands[1]) || ! STACK_REG_P (operands[2]))
! 	abort ();
! 
!       if (find_regno_note (insn, REG_DEAD, REGNO (operands[2])))
! 	return strcat (buf, AS2 (rp,%2,%0));
! 
!       if (find_regno_note (insn, REG_DEAD, REGNO (operands[1])))
! 	return strcat (buf, AS2 (p,%1,%0));
! 
!       if (STACK_TOP_P (operands[0]))
  	{
! 	  if (STACK_TOP_P (operands[1]))
! 	    return strcat (buf, AS2C (%y2,%0));
  	  else
! 	    return strcat (buf, AS2 (r,%y1,%0));
  	}
!       else if (STACK_TOP_P (operands[1]))
! 	return strcat (buf, AS2C (%1,%0));
!       else
! 	return strcat (buf, AS2 (r,%2,%0));
! 
!     default:
!       abort ();
      }
  }
- 
- /* Output code for INSN to convert a float to a signed int.  OPERANDS
-    are the insn operands.  The output may be SFmode or DFmode and the
-    input operand may be SImode or DImode.  As a special case, make sure
-    that the 387 stack top dies if the output mode is DImode, because the
-    hardware requires this.  */
  
! char *
! output_fix_trunc (insn, operands)
!      rtx insn;
!      rtx *operands;
  {
!   int stack_top_dies = find_regno_note (insn, REG_DEAD, FIRST_STACK_REG) != 0;
!   rtx xops[2];
  
!   if (! STACK_TOP_P (operands[1]) ||
!       (GET_MODE (operands[0]) == DImode && ! stack_top_dies))
!     abort ();
! 
!   xops[0] = GEN_INT (12);
!   xops[1] = operands[4];
! 
!   output_asm_insn (AS1 (fnstc%W2,%2), operands);
!   output_asm_insn (AS2 (mov%L2,%2,%4), operands);
!   output_asm_insn (AS2 (mov%B1,%0,%h1), xops);
!   output_asm_insn (AS2 (mov%L4,%4,%3), operands);
!   output_asm_insn (AS1 (fldc%W3,%3), operands);
! 
!   if (NON_STACK_REG_P (operands[0]))
!     output_to_reg (operands[0], stack_top_dies);
!   else if (GET_CODE (operands[0]) == MEM)
      {
!       if (stack_top_dies)
! 	output_asm_insn (AS1 (fistp%z0,%0), operands);
        else
! 	output_asm_insn (AS1 (fist%z0,%0), operands);
      }
!   else
!     abort ();
! 
!   return AS1 (fldc%W2,%2);
  }
- 
- /* Output code for INSN to compare OPERANDS.  The two operands might
-    not have the same mode: one might be within a FLOAT or FLOAT_EXTEND
-    expression.  If the compare is in mode CCFPEQmode, use an opcode that
-    will not fault if a qNaN is present. */
  
! char *
! output_float_compare (insn, operands)
!      rtx insn;
!      rtx *operands;
  {
!   int stack_top_dies;
!   rtx body = XVECEXP (PATTERN (insn), 0, 0);
!   int unordered_compare = GET_MODE (SET_SRC (body)) == CCFPEQmode;
! 
!   if (! STACK_TOP_P (operands[0]))
!     abort ();
! 
!   stack_top_dies = find_regno_note (insn, REG_DEAD, FIRST_STACK_REG) != 0;
! 
!   if (STACK_REG_P (operands[1])
!       && stack_top_dies
!       && find_regno_note (insn, REG_DEAD, REGNO (operands[1]))
!       && REGNO (operands[1]) != FIRST_STACK_REG)
!     {
!       /* If both the top of the 387 stack dies, and the other operand
! 	 is also a stack register that dies, then this must be a
! 	 `fcompp' float compare */
! 
!       if (unordered_compare)
! 	output_asm_insn ("fucompp", operands);
!       else
! 	output_asm_insn ("fcompp", operands);
!     }
!   else
      {
!       static char buf[100];
! 
!       /* Decide if this is the integer or float compare opcode, or the
! 	 unordered float compare. */
! 
!       if (unordered_compare)
! 	strcpy (buf, "fucom");
!       else if (GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_FLOAT)
! 	strcpy (buf, "fcom");
!       else
! 	strcpy (buf, "ficom");
! 
!       /* Modify the opcode if the 387 stack is to be popped. */
! 
!       if (stack_top_dies)
! 	strcat (buf, "p");
! 
!       if (NON_STACK_REG_P (operands[1]))
! 	output_op_from_reg (operands[1], strcat (buf, AS1 (%z0,%1)));
!       else
!         output_asm_insn (strcat (buf, AS1 (%z1,%y1)), operands);
!     }
  
!   /* Now retrieve the condition code. */
  
!   return output_fp_cc0_set (insn);
  }
- 
- /* Output opcodes to transfer the results of FP compare or test INSN
-    from the FPU to the CPU flags.  If TARGET_IEEE_FP, ensure that if the
-    result of the compare or test is unordered, no comparison operator
-    succeeds except NE.  Return an output template, if any.  */
  
! char *
! output_fp_cc0_set (insn)
!      rtx insn;
  {
!   rtx xops[3];
!   rtx unordered_label;
!   rtx next;
!   enum rtx_code code;
  
!   xops[0] = gen_rtx (REG, HImode, 0);
!   output_asm_insn (AS1 (fnsts%W0,%0), xops);
  
!   if (! TARGET_IEEE_FP)
!     return "sahf";
  
-   next = next_cc0_user (insn);
-   if (next == NULL_RTX)
-     abort ();
  
!   if (GET_CODE (next) == JUMP_INSN
!       && GET_CODE (PATTERN (next)) == SET
!       && SET_DEST (PATTERN (next)) == pc_rtx
!       && GET_CODE (SET_SRC (PATTERN (next))) == IF_THEN_ELSE)
!     {
!       code = GET_CODE (XEXP (SET_SRC (PATTERN (next)), 0));
!     }
!   else if (GET_CODE (PATTERN (next)) == SET)
      {
!       code = GET_CODE (SET_SRC (PATTERN (next)));
      }
!   else
!     abort ();
  
!   xops[0] = gen_rtx (REG, QImode, 0);
  
!   switch (code)
      {
!     case GT:
!       xops[1] = GEN_INT (0x45);
!       output_asm_insn (AS2 (and%B0,%1,%h0), xops);
!       /* je label */
!       break;
  
-     case LT:
-       xops[1] = GEN_INT (0x45);
-       xops[2] = GEN_INT (0x01);
-       output_asm_insn (AS2 (and%B0,%1,%h0), xops);
-       output_asm_insn (AS2 (cmp%B0,%2,%h0), xops);
-       /* je label */
-       break;
  
!     case GE:
!       xops[1] = GEN_INT (0x05);
!       output_asm_insn (AS2 (and%B0,%1,%h0), xops);
!       /* je label */
!       break;
  
-     case LE:
-       xops[1] = GEN_INT (0x45);
-       xops[2] = GEN_INT (0x40);
-       output_asm_insn (AS2 (and%B0,%1,%h0), xops);
-       output_asm_insn (AS1 (dec%B0,%h0), xops);
-       output_asm_insn (AS2 (cmp%B0,%2,%h0), xops);
-       /* jb label */
-       break;
  
-     case EQ:
-       xops[1] = GEN_INT (0x45);
-       xops[2] = GEN_INT (0x40);
-       output_asm_insn (AS2 (and%B0,%1,%h0), xops);
-       output_asm_insn (AS2 (cmp%B0,%2,%h0), xops);
-       /* je label */
-       break;
  
-     case NE:
-       xops[1] = GEN_INT (0x44);
-       xops[2] = GEN_INT (0x40);
-       output_asm_insn (AS2 (and%B0,%1,%h0), xops);
-       output_asm_insn (AS2 (xor%B0,%2,%h0), xops);
-       /* jne label */
-       break;
  
!     case GTU:
!     case LTU:
!     case GEU:
!     case LEU:
!     default:
!       abort ();
      }
!   RET;
  }
- 
- #define MAX_386_STACK_LOCALS 2
  
! static rtx i386_stack_locals[(int) MAX_MACHINE_MODE][MAX_386_STACK_LOCALS];
  
! /* Define the structure for the machine field in struct function.  */
! struct machine_function
  {
!   rtx i386_stack_locals[(int) MAX_MACHINE_MODE][MAX_386_STACK_LOCALS];
! };
  
- /* Functions to save and restore i386_stack_locals.
-    These will be called, via pointer variables,
-    from push_function_context and pop_function_context.  */
  
! void
! save_386_machine_status (p)
!      struct function *p;
  {
!   p->machine = (struct machine_function *) xmalloc (sizeof i386_stack_locals);
!   bcopy ((char *) i386_stack_locals, (char *) p->machine->i386_stack_locals,
! 	 sizeof i386_stack_locals);
  }
  
! void
! restore_386_machine_status (p)
!      struct function *p;
  {
!   bcopy ((char *) p->machine->i386_stack_locals, (char *) i386_stack_locals,
! 	 sizeof i386_stack_locals);
!   free (p->machine);
  }
  
- /* Clear stack slot assignments remembered from previous functions.
-    This is called from INIT_EXPANDERS once before RTL is emitted for each
-    function.  */
  
! void
! clear_386_stack_locals ()
  {
!   enum machine_mode mode;
!   int n;
  
!   for (mode = VOIDmode; (int) mode < (int) MAX_MACHINE_MODE;
!        mode = (enum machine_mode) ((int) mode + 1))
!     for (n = 0; n < MAX_386_STACK_LOCALS; n++)
!       i386_stack_locals[(int) mode][n] = NULL_RTX;
  
!   /* Arrange to save and restore i386_stack_locals around nested functions.  */
!   save_machine_status = save_386_machine_status;
!   restore_machine_status = restore_386_machine_status;
! }
  
! /* Return a MEM corresponding to a stack slot with mode MODE.
!    Allocate a new slot if necessary.
  
!    The RTL for a function can have several slots available: N is
!    which slot to use.  */
  
- rtx
- assign_386_stack_local (mode, n)
-      enum machine_mode mode;
-      int n;
- {
-   if (n < 0 || n >= MAX_386_STACK_LOCALS)
-     abort ();
  
!   if (i386_stack_locals[(int) mode][n] == NULL_RTX)
!     i386_stack_locals[(int) mode][n]
!       = assign_stack_local (mode, GET_MODE_SIZE (mode), 0);
  
!   return i386_stack_locals[(int) mode][n];
  }
--- 1429,3510 ----
    else
      output_asm_insn ("ret", xops);
  }
  
! /* Print an integer constant expression in assembler syntax.  Addition
!    and subtraction are the only arithmetic that may appear in these
!    expressions.  FILE is the stdio stream to write to, X is the rtx, and
!    CODE is the operand print code from the output string.  */
  
! static void
! output_pic_addr_const (file, x, code)
!      FILE *file;
!      rtx x;
!      int code;
  {
!   char buf[256];
  
!   switch (GET_CODE (x))
      {
!     case PC:
!       if (flag_pic)
! 	putc ('.', file);
!       else
! 	abort ();
!       break;
  
!     case SYMBOL_REF:
!     case LABEL_REF:
!       if (GET_CODE (x) == SYMBOL_REF)
! 	assemble_name (file, XSTR (x, 0));
!       else
  	{
! 	  ASM_GENERATE_INTERNAL_LABEL (buf, "L",
! 				       CODE_LABEL_NUMBER (XEXP (x, 0)));
! 	  assemble_name (asm_out_file, buf);
  	}
  
+       if (GET_CODE (x) == SYMBOL_REF && CONSTANT_POOL_ADDRESS_P (x))
+ 	fprintf (file, "@GOTOFF(%%ebx)");
+       else if (code == 'P')
+ 	fprintf (file, "@PLT");
+       else if (GET_CODE (x) == LABEL_REF || ! SYMBOL_REF_FLAG (x))
+ 	fprintf (file, "@GOT");
        else
! 	fprintf (file, "@GOTOFF");
  
!       break;
  
!     case CODE_LABEL:
!       ASM_GENERATE_INTERNAL_LABEL (buf, "L", CODE_LABEL_NUMBER (x));
!       assemble_name (asm_out_file, buf);
!       break;
  
!     case CONST_INT:
!       fprintf (file, "%d", INTVAL (x));
!       break;
  
!     case CONST:
!       /* This used to output parentheses around the expression,
! 	 but that does not work on the 386 (either ATT or BSD assembler).  */
!       output_pic_addr_const (file, XEXP (x, 0), code);
!       break;
  
!     case CONST_DOUBLE:
!       if (GET_MODE (x) == VOIDmode)
  	{
! 	  /* We can use %d if the number is <32 bits and positive.  */
! 	  if (CONST_DOUBLE_HIGH (x) || CONST_DOUBLE_LOW (x) < 0)
! 	    fprintf (file, "0x%x%08x",
! 		     CONST_DOUBLE_HIGH (x), CONST_DOUBLE_LOW (x));
! 	  else
! 	    fprintf (file, "%d", CONST_DOUBLE_LOW (x));
  	}
!       else
! 	/* We can't handle floating point constants;
! 	   PRINT_OPERAND must handle them.  */
! 	output_operand_lossage ("floating constant misused");
!       break;
  
!     case PLUS:
!       /* Some assemblers need integer constants to appear last (eg masm).  */
!       if (GET_CODE (XEXP (x, 0)) == CONST_INT)
  	{
! 	  output_pic_addr_const (file, XEXP (x, 1), code);
! 	  if (INTVAL (XEXP (x, 0)) >= 0)
! 	    fprintf (file, "+");
! 	  output_pic_addr_const (file, XEXP (x, 0), code);
  	}
!       else
  	{
! 	  output_pic_addr_const (file, XEXP (x, 0), code);
! 	  if (INTVAL (XEXP (x, 1)) >= 0)
! 	    fprintf (file, "+");
! 	  output_pic_addr_const (file, XEXP (x, 1), code);
  	}
!       break;
  
!     case MINUS:
!       output_pic_addr_const (file, XEXP (x, 0), code);
!       fprintf (file, "-");
!       output_pic_addr_const (file, XEXP (x, 1), code);
!       break;
  
!     default:
!       output_operand_lossage ("invalid expression as operand");
      }
+ }
+ 
+ /* Meaning of CODE:
+    f -- float insn (print a CONST_DOUBLE as a float rather than in hex).
+    D,L,W,B,Q,S -- print the opcode suffix for specified size of operand.
+    R -- print the prefix for register names.
+    z -- print the opcode suffix for the size of the current operand.
+    * -- print a star (in certain assembler syntax)
+    w -- print the operand as if it's a "word" (HImode) even if it isn't.
+    c -- don't print special prefixes before constant operands.
+    J -- print the appropriate jump operand.
+ */
  
! void
! print_operand (file, x, code)
!      FILE *file;
!      rtx x;
!      int code;
! {
!   if (code)
      {
!       switch (code)
  	{
! 	case '*':
! 	  if (USE_STAR)
! 	    putc ('*', file);
! 	  return;
  
! 	case 'L':
! 	  PUT_OP_SIZE (code, 'l', file);
! 	  return;
  
! 	case 'W':
! 	  PUT_OP_SIZE (code, 'w', file);
! 	  return;
  
! 	case 'B':
! 	  PUT_OP_SIZE (code, 'b', file);
! 	  return;
  
! 	case 'Q':
! 	  PUT_OP_SIZE (code, 'l', file);
! 	  return;
  
! 	case 'S':
! 	  PUT_OP_SIZE (code, 's', file);
! 	  return;
  
! 	case 'T':
! 	  PUT_OP_SIZE (code, 't', file);
! 	  return;
  
! 	case 'z':
! 	  /* 387 opcodes don't get size suffixes if the operands are
! 	     registers. */
  
! 	  if (STACK_REG_P (x))
! 	    return;
  
! 	  /* this is the size of op from size of operand */
! 	  switch (GET_MODE_SIZE (GET_MODE (x)))
! 	    {
! 	    case 1:
! 	      PUT_OP_SIZE ('B', 'b', file);
! 	      return;
  
! 	    case 2:
! 	      PUT_OP_SIZE ('W', 'w', file);
! 	      return;
  
! 	    case 4:
! 	      if (GET_MODE (x) == SFmode)
! 		{
! 		  PUT_OP_SIZE ('S', 's', file);
! 		  return;
! 		}
! 	      else
! 		PUT_OP_SIZE ('L', 'l', file);
! 	      return;
  
! 	    case 12:
! 		  PUT_OP_SIZE ('T', 't', file);
! 		  return;
  
! 	    case 8:
! 	      if (GET_MODE_CLASS (GET_MODE (x)) == MODE_INT)
! 		{
! #ifdef GAS_MNEMONICS
! 		  PUT_OP_SIZE ('Q', 'q', file);
! 		  return;
! #else
! 		  PUT_OP_SIZE ('Q', 'l', file);	/* Fall through */
! #endif
! 		}
  
! 	      PUT_OP_SIZE ('Q', 'l', file);
! 	      return;
! 	    }
  
! 	case 'b':
! 	case 'w':
! 	case 'k':
! 	case 'h':
! 	case 'y':
! 	case 'P':
! 	  break;
  
! 	case 'J':
! 	  switch (GET_CODE (x))
! 	    {
! 	      /* These conditions are appropriate for testing the result
! 		 of an arithmetic operation, not for a compare operation.
! 	         Cases GE, LT assume CC_NO_OVERFLOW true. All cases assume
! 		 CC_Z_IN_NOT_C false and not floating point.  */
! 	    case NE:  fputs ("jne", file); return;
! 	    case EQ:  fputs ("je",  file); return;
! 	    case GE:  fputs ("jns", file); return;
! 	    case LT:  fputs ("js",  file); return;
! 	    case GEU: fputs ("jmp", file); return;
! 	    case GTU: fputs ("jne",  file); return;
! 	    case LEU: fputs ("je", file); return;
! 	    case LTU: fputs ("#branch never",  file); return;
  
! 	    /* no matching branches for GT nor LE */
! 	    }
! 	  abort ();
  
! 	default:
! 	  {
! 	    char str[50];
  
! 	    sprintf (str, "invalid operand code `%c'", code);
! 	    output_operand_lossage (str);
! 	  }
! 	}
!     }
!   if (GET_CODE (x) == REG)
!     {
!       PRINT_REG (x, code, file);
!     }
!   else if (GET_CODE (x) == MEM)
!     {
!       PRINT_PTR (x, file);
!       if (CONSTANT_ADDRESS_P (XEXP (x, 0)))
  	{
! 	  if (flag_pic)
! 	    output_pic_addr_const (file, XEXP (x, 0), code);
! 	  else
! 	    output_addr_const (file, XEXP (x, 0));
  	}
!       else
! 	output_address (XEXP (x, 0));
!     }
!   else if (GET_CODE (x) == CONST_DOUBLE && GET_MODE (x) == SFmode)
!     {
!       REAL_VALUE_TYPE r; long l;
!       REAL_VALUE_FROM_CONST_DOUBLE (r, x);
!       REAL_VALUE_TO_TARGET_SINGLE (r, l);
!       PRINT_IMMED_PREFIX (file);
!       fprintf (file, "0x%x", l);
!     }
!  /* These float cases don't actually occur as immediate operands. */
!  else if (GET_CODE (x) == CONST_DOUBLE && GET_MODE (x) == DFmode)
!     {
!       REAL_VALUE_TYPE r; char dstr[30];
!       REAL_VALUE_FROM_CONST_DOUBLE (r, x);
!       REAL_VALUE_TO_DECIMAL (r, "%.22e", dstr);
!       fprintf (file, "%s", dstr);
!     }
!   else if (GET_CODE (x) == CONST_DOUBLE && GET_MODE (x) == XFmode)
!     {
!       REAL_VALUE_TYPE r; char dstr[30];
!       REAL_VALUE_FROM_CONST_DOUBLE (r, x);
!       REAL_VALUE_TO_DECIMAL (r, "%.22e", dstr);
!       fprintf (file, "%s", dstr);
!     }
!   else 
!     {
!       if (code != 'P')
! 	{
! 	  if (GET_CODE (x) == CONST_INT || GET_CODE (x) == CONST_DOUBLE)
! 	    PRINT_IMMED_PREFIX (file);
! 	  else if (GET_CODE (x) == CONST || GET_CODE (x) == SYMBOL_REF
! 		   || GET_CODE (x) == LABEL_REF)
! 	    PRINT_OFFSET_PREFIX (file);
! 	}
!       if (flag_pic)
! 	output_pic_addr_const (file, x, code);
!       else
! 	output_addr_const (file, x);
      }
  }
  
! /* Print a memory operand whose address is ADDR.  */
  
  void
! print_operand_address (file, addr)
!      FILE *file;
!      register rtx addr;
  {
!   register rtx reg1, reg2, breg, ireg;
!   rtx offset;
  
!   switch (GET_CODE (addr))
      {
!     case REG:
!       ADDR_BEG (file);
!       fprintf (file, "%se", RP);
!       fputs (hi_reg_name[REGNO (addr)], file);
!       ADDR_END (file);
!       break;
  
!     case PLUS:
!       reg1 = 0;
!       reg2 = 0;
!       ireg = 0;
!       breg = 0;
!       offset = 0;
!       if (CONSTANT_ADDRESS_P (XEXP (addr, 0)))
  	{
! 	  offset = XEXP (addr, 0);
! 	  addr = XEXP (addr, 1);
  	}
!       else if (CONSTANT_ADDRESS_P (XEXP (addr, 1)))
  	{
! 	  offset = XEXP (addr, 1);
! 	  addr = XEXP (addr, 0);
  	}
!       if (GET_CODE (addr) != PLUS) ;
!       else if (GET_CODE (XEXP (addr, 0)) == MULT)
  	{
! 	  reg1 = XEXP (addr, 0);
! 	  addr = XEXP (addr, 1);
  	}
!       else if (GET_CODE (XEXP (addr, 1)) == MULT)
! 	{
! 	  reg1 = XEXP (addr, 1);
! 	  addr = XEXP (addr, 0);
! 	}
!       else if (GET_CODE (XEXP (addr, 0)) == REG)
! 	{
! 	  reg1 = XEXP (addr, 0);
! 	  addr = XEXP (addr, 1);
! 	}
!       else if (GET_CODE (XEXP (addr, 1)) == REG)
! 	{
! 	  reg1 = XEXP (addr, 1);
! 	  addr = XEXP (addr, 0);
! 	}
!       if (GET_CODE (addr) == REG || GET_CODE (addr) == MULT)
! 	{
! 	  if (reg1 == 0) reg1 = addr;
! 	  else reg2 = addr;
! 	  addr = 0;
! 	}
!       if (offset != 0)
! 	{
! 	  if (addr != 0) abort ();
! 	  addr = offset;
! 	}
!       if ((reg1 && GET_CODE (reg1) == MULT)
! 	  || (reg2 != 0 && REGNO_OK_FOR_BASE_P (REGNO (reg2))))
! 	{
! 	  breg = reg2;
! 	  ireg = reg1;
! 	}
!       else if (reg1 != 0 && REGNO_OK_FOR_BASE_P (REGNO (reg1)))
  	{
! 	  breg = reg1;
! 	  ireg = reg2;
  	}
  
!       if (ireg != 0 || breg != 0)
  	{
! 	  int scale = 1;
  
! 	  if (addr != 0)
  	    {
! 	      if (GET_CODE (addr) == LABEL_REF)
! 		output_asm_label (addr);
! 	      else
! 		{
! 		  if (flag_pic)
! 		    output_pic_addr_const (file, addr, 0);
! 		  else
! 		    output_addr_const (file, addr);
! 		}
  	    }
  
!   	  if (ireg != 0 && GET_CODE (ireg) == MULT)
  	    {
! 	      scale = INTVAL (XEXP (ireg, 1));
! 	      ireg = XEXP (ireg, 0);
  	    }
  
! 	  /* The stack pointer can only appear as a base register,
! 	     never an index register, so exchange the regs if it is wrong. */
  
! 	  if (scale == 1 && ireg && REGNO (ireg) == STACK_POINTER_REGNUM)
! 	    {
! 	      rtx tmp;
  
! 	      tmp = breg;
! 	      breg = ireg;
! 	      ireg = tmp;
! 	    }
  
! 	  /* output breg+ireg*scale */
! 	  PRINT_B_I_S (breg, ireg, scale, file);
! 	  break;
  	}
  
!     case MULT:
!       {
! 	int scale;
! 	if (GET_CODE (XEXP (addr, 0)) == CONST_INT)
! 	  {
! 	    scale = INTVAL (XEXP (addr, 0));
! 	    ireg = XEXP (addr, 1);
! 	  }
! 	else
! 	  {
! 	    scale = INTVAL (XEXP (addr, 1));
! 	    ireg = XEXP (addr, 0);
! 	  }
! 	output_addr_const (file, const0_rtx);
! 	PRINT_B_I_S ((rtx) 0, ireg, scale, file);
!       }
!       break;
  
!     default:
!       if (GET_CODE (addr) == CONST_INT
! 	  && INTVAL (addr) < 0x8000
! 	  && INTVAL (addr) >= -0x8000)
! 	fprintf (file, "%d", INTVAL (addr));
!       else
  	{
! 	  if (flag_pic)
! 	    output_pic_addr_const (file, addr, 0);
! 	  else
! 	    output_addr_const (file, addr);
  	}
      }
  }
  
! /* Set the cc_status for the results of an insn whose pattern is EXP.
!    On the 80386, we assume that only test and compare insns, as well
!    as SI, HI, & DI mode ADD, SUB, NEG, AND, IOR, XOR, ASHIFT, LSHIFT,
!    ASHIFTRT, and LSHIFTRT instructions set the condition codes usefully.
!    Also, we assume that jumps, moves and sCOND don't affect the condition
!    codes.  All else clobbers the condition codes, by assumption.
  
!    We assume that ALL integer add, minus, etc. instructions effect the
!    condition codes.  This MUST be consistent with i386.md.
  
!    We don't record any float test or compare - the redundant test &
!    compare check in final.c does not handle stack-like regs correctly. */
! 
! void
! notice_update_cc (exp)
!      rtx exp;
! {
!   if (GET_CODE (exp) == SET)
      {
!       /* Jumps do not alter the cc's.  */
!       if (SET_DEST (exp) == pc_rtx)
! 	return;
! #ifdef IS_STACK_MODE
!       /* intel1 
!          Moving into a memory of stack_mode may have been moved
!          in between the use and set of cc0 by loop_spl(). So
!          old value of cc.status must be retained */
!       if(GET_CODE(SET_DEST(exp))==MEM 
!          && IS_STACK_MODE(GET_MODE(SET_DEST(exp))))
!         {
!           return;
!         }
! #endif
!       /* Moving register or memory into a register:
! 	 it doesn't alter the cc's, but it might invalidate
! 	 the RTX's which we remember the cc's came from.
! 	 (Note that moving a constant 0 or 1 MAY set the cc's).  */
!       if (REG_P (SET_DEST (exp))
! 	  && (REG_P (SET_SRC (exp)) || GET_CODE (SET_SRC (exp)) == MEM
! 	      || GET_RTX_CLASS (GET_CODE (SET_SRC (exp))) == '<'))
  	{
! 	  if (cc_status.value1
! 	      && reg_overlap_mentioned_p (SET_DEST (exp), cc_status.value1))
! 	    cc_status.value1 = 0;
! 	  if (cc_status.value2
! 	      && reg_overlap_mentioned_p (SET_DEST (exp), cc_status.value2))
! 	    cc_status.value2 = 0;
! 	  return;
  	}
+       /* Moving register into memory doesn't alter the cc's.
+ 	 It may invalidate the RTX's which we remember the cc's came from.  */
+       if (GET_CODE (SET_DEST (exp)) == MEM
+ 	  && (REG_P (SET_SRC (exp))
+ 	      || GET_RTX_CLASS (GET_CODE (SET_SRC (exp))) == '<'))
+ 	{
+ 	  if (cc_status.value1 && GET_CODE (cc_status.value1) == MEM)
+ 	    cc_status.value1 = 0;
+ 	  if (cc_status.value2 && GET_CODE (cc_status.value2) == MEM)
+ 	    cc_status.value2 = 0;
+ 	  return;
+ 	}
+       /* Function calls clobber the cc's.  */
+       else if (GET_CODE (SET_SRC (exp)) == CALL)
+ 	{
+ 	  CC_STATUS_INIT;
+ 	  return;
+ 	}
+       /* Tests and compares set the cc's in predictable ways.  */
+       else if (SET_DEST (exp) == cc0_rtx)
+ 	{
+ 	  CC_STATUS_INIT;
+ 	  cc_status.value1 = SET_SRC (exp);
+ 	  return;
+ 	}
+       /* Certain instructions effect the condition codes. */
+       else if (GET_MODE (SET_SRC (exp)) == SImode
+ 	       || GET_MODE (SET_SRC (exp)) == HImode
+ 	       || GET_MODE (SET_SRC (exp)) == QImode)
+ 	switch (GET_CODE (SET_SRC (exp)))
+ 	  {
+ 	  case ASHIFTRT: case LSHIFTRT:
+ 	  case ASHIFT: case LSHIFT:
+ 	    /* Shifts on the 386 don't set the condition codes if the
+ 	       shift count is zero. */
+ 	    if (GET_CODE (XEXP (SET_SRC (exp), 1)) != CONST_INT)
+ 	      {
+ 		CC_STATUS_INIT;
+ 		break;
+ 	      }
+ 	    /* We assume that the CONST_INT is non-zero (this rtx would
+ 	       have been deleted if it were zero. */
  
! 	  case PLUS: case MINUS: case NEG:
! 	  case AND: case IOR: case XOR:
! 	    cc_status.flags = CC_NO_OVERFLOW;
! 	    cc_status.value1 = SET_SRC (exp);
! 	    cc_status.value2 = SET_DEST (exp);
! 	    break;
  
! 	  default:
! 	    CC_STATUS_INIT;
! 	  }
!       else
  	{
! 	  CC_STATUS_INIT;
! 	}
!     }
!   else if (GET_CODE (exp) == PARALLEL
! 	   && GET_CODE (XVECEXP (exp, 0, 0)) == SET)
!     {
!       if (SET_DEST (XVECEXP (exp, 0, 0)) == pc_rtx)
! 	return;
!       if (SET_DEST (XVECEXP (exp, 0, 0)) == cc0_rtx)
! 	{
! 	  CC_STATUS_INIT;
! 	  if (stack_regs_mentioned_p (SET_SRC (XVECEXP (exp, 0, 0))))
! 	    cc_status.flags |= CC_IN_80387;
  	  else
! 	    cc_status.value1 = SET_SRC (XVECEXP (exp, 0, 0));
! 	  return;
  	}
!       CC_STATUS_INIT;
!     }
!   else
!     {
!       CC_STATUS_INIT;
!     }
! }
! 
! /* Split one or more DImode RTL references into pairs of SImode
!    references.  The RTL can be REG, offsettable MEM, integer constant, or
!    CONST_DOUBLE.  "operands" is a pointer to an array of DImode RTL to
!    split and "num" is its length.  lo_half and hi_half are output arrays
!    that parallel "operands". */
  
! void
! split_di (operands, num, lo_half, hi_half)
!      rtx operands[];
!      int num;
!      rtx lo_half[], hi_half[];
! {
!   while (num--)
!     {
!       if (GET_CODE (operands[num]) == REG)
  	{
! 	  lo_half[num] = gen_rtx (REG, SImode, REGNO (operands[num]));
! 	  hi_half[num] = gen_rtx (REG, SImode, REGNO (operands[num]) + 1);
  	}
!       else if (CONSTANT_P (operands[num]))
  	{
! 	  split_double (operands[num], &lo_half[num], &hi_half[num]);
  	}
!       else if (offsettable_memref_p (operands[num]))
! 	{
! 	  lo_half[num] = operands[num];
! 	  hi_half[num] = adj_offsettable_operand (operands[num], 4);
! 	}
!       else
! 	abort();
!     }
! }
! 
! /* Return 1 if this is a valid binary operation on a 387.
!    OP is the expression matched, and MODE is its mode. */
! 
! int
! binary_387_op (op, mode)
!     register rtx op;
!     enum machine_mode mode;
! {
!   if (mode != VOIDmode && mode != GET_MODE (op))
!     return 0;
  
+   switch (GET_CODE (op))
+     {
+     case PLUS:
      case MINUS:
!     case MULT:
!     case DIV:
!       return GET_MODE_CLASS (GET_MODE (op)) == MODE_FLOAT;
  
      default:
!       return 0;
      }
  }
  
! /* Return 1 if this is a valid conversion operation on a 387.
!    OP is the expression matched, and MODE is its mode. */
! 
! int
! convert_387_op (op, mode)
!     register rtx op;
!     enum machine_mode mode;
  {
!   if (mode != VOIDmode && mode != GET_MODE (op))
!     return 0;
! 
!   switch (GET_CODE (op))
      {
!     case FLOAT:
!       return GET_MODE (XEXP (op, 0)) == SImode;
  
!     case FLOAT_EXTEND:
!       return ((mode == DFmode && GET_MODE (XEXP (op, 0)) == SFmode)
! 	      || (mode == XFmode && GET_MODE (XEXP (op, 0)) == DFmode)
! 	      || (mode == XFmode && GET_MODE (XEXP (op, 0)) == SFmode));
  
!     default:
!       return 0;
!     }
! }
  
! /* Return 1 if this is a valid shift or rotate operation on a 386.
!    OP is the expression matched, and MODE is its mode. */
  
! int
! shift_op (op, mode)
!     register rtx op;
!     enum machine_mode mode;
! {
!   rtx operand = XEXP (op, 0);
  
!   if (mode != VOIDmode && mode != GET_MODE (op))
!     return 0;
  
!   if (GET_MODE (operand) != GET_MODE (op)
!       || GET_MODE_CLASS (GET_MODE (op)) != MODE_INT)
!     return 0;
  
!   return (GET_CODE (op) == ASHIFT
! 	  || GET_CODE (op) == ASHIFTRT
! 	  || GET_CODE (op) == LSHIFTRT
! 	  || GET_CODE (op) == ROTATE
! 	  || GET_CODE (op) == ROTATERT);
! }
  
! /* Return 1 if OP is COMPARE rtx with mode VOIDmode.
!    MODE is not used.  */
  
! int
! VOIDmode_compare_op (op, mode)
!     register rtx op;
!     enum machine_mode mode;
! {
!   return GET_CODE (op) == COMPARE && GET_MODE (op) == VOIDmode;
! }
! 
! /* Output code to perform a 387 binary operation in INSN, one of PLUS,
!    MINUS, MULT or DIV.  OPERANDS are the insn operands, where operands[3]
!    is the expression of the binary operation.  The output may either be
!    emitted here, or returned to the caller, like all output_* functions.
  
!    There is no guarantee that the operands are the same mode, as they
!    might be within FLOAT or FLOAT_EXTEND expressions. */
  
! char *
! output_387_binary_op (insn, operands)
!      rtx insn;
!      rtx *operands;
! {
!   rtx temp;
!   char *base_op;
!   static char buf[100];
  
!   switch (GET_CODE (operands[3]))
!     {
!     case PLUS:
!       if (GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_INT
! 	  || GET_MODE_CLASS (GET_MODE (operands[2])) == MODE_INT)
! 	base_op = "fiadd";
!       else
! 	base_op = "fadd";
!       break;
  
!     case MINUS:
!       if (GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_INT
! 	  || GET_MODE_CLASS (GET_MODE (operands[2])) == MODE_INT)
! 	base_op = "fisub";
!       else
! 	base_op = "fsub";
!       break;
  
!     case MULT:
!       if (GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_INT
! 	  || GET_MODE_CLASS (GET_MODE (operands[2])) == MODE_INT)
! 	base_op = "fimul";
!       else
! 	base_op = "fmul";
!       break;
  
!     case DIV:
!       if (GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_INT
! 	  || GET_MODE_CLASS (GET_MODE (operands[2])) == MODE_INT)
! 	base_op = "fidiv";
!       else
! 	base_op = "fdiv";
!       break;
  
!     default:
!       abort ();
!     }
  
!   strcpy (buf, base_op);
  
!   switch (GET_CODE (operands[3]))
      {
!     case MULT:
!     case PLUS:
!       if (REG_P (operands[2]) && REGNO (operands[0]) == REGNO (operands[2]))
  	{
! 	  temp = operands[2];
! 	  operands[2] = operands[1];
! 	  operands[1] = temp;
  	}
  
!       if (GET_CODE (operands[2]) == MEM)
! 	return strcat (buf, AS1 (%z2,%2));
  
!       if (NON_STACK_REG_P (operands[1]))
  	{
! 	  output_op_from_reg (operands[1], strcat (buf, AS1 (%z0,%1)));
! 	  RET;
  	}
!       else if (NON_STACK_REG_P (operands[2]))
  	{
! 	  output_op_from_reg (operands[2], strcat (buf, AS1 (%z0,%1)));
! 	  RET;
  	}
! 
!       if (find_regno_note (insn, REG_DEAD, REGNO (operands[2])))
! 	return strcat (buf, AS2 (p,%2,%0));
! 
!       if (STACK_TOP_P (operands[0]))
! 	return strcat (buf, AS2 (,%y2,%0));
!       else
! 	return strcat (buf, AS2 (,%2,%0));
! 
!     case MINUS:
!     case DIV:
!       if (GET_CODE (operands[1]) == MEM)
! 	return strcat (buf, AS1 (r%z1,%1));
! 
!       if (GET_CODE (operands[2]) == MEM)
! 	return strcat (buf, AS1 (%z2,%2));
! 
!       if (NON_STACK_REG_P (operands[1]))
  	{
! 	  output_op_from_reg (operands[1], strcat (buf, AS1 (r%z0,%1)));
! 	  RET;
  	}
!       else if (NON_STACK_REG_P (operands[2]))
  	{
! 	  output_op_from_reg (operands[2], strcat (buf, AS1 (%z0,%1)));
! 	  RET;
  	}
! 
!       if (! STACK_REG_P (operands[1]) || ! STACK_REG_P (operands[2]))
! 	abort ();
! 
!       if (find_regno_note (insn, REG_DEAD, REGNO (operands[2])))
! 	return strcat (buf, AS2 (rp,%2,%0));
! 
!       if (find_regno_note (insn, REG_DEAD, REGNO (operands[1])))
! 	return strcat (buf, AS2 (p,%1,%0));
! 
!       if (STACK_TOP_P (operands[0]))
  	{
! 	  if (STACK_TOP_P (operands[1]))
! 	    return strcat (buf, AS2 (,%y2,%0));
! 	  else
! 	    return strcat (buf, AS2 (r,%y1,%0));
  	}
+       else if (STACK_TOP_P (operands[1]))
+ 	return strcat (buf, AS2 (,%1,%0));
+       else
+ 	return strcat (buf, AS2 (r,%2,%0));
  
!     default:
!       abort ();
!     }
! }
! 
! /* Output code for INSN to convert a float to a signed int.  OPERANDS
!    are the insn operands.  The output may be SFmode or DFmode and the
!    input operand may be SImode or DImode.  As a special case, make sure
!    that the 387 stack top dies if the output mode is DImode, because the
!    hardware requires this.  */
  
! char *
! output_fix_trunc (insn, operands)
!      rtx insn;
!      rtx *operands;
! {
!   int stack_top_dies = find_regno_note (insn, REG_DEAD, FIRST_STACK_REG) != 0;
!   rtx xops[2];
  
!   if (! STACK_TOP_P (operands[1]) ||
!       (GET_MODE (operands[0]) == DImode && ! stack_top_dies))
!     abort ();
  
!   xops[0] = GEN_INT (12);
!   xops[1] = operands[4];
  
!   output_asm_insn (AS1 (fnstc%W2,%2), operands);
!   output_asm_insn (AS2 (mov%L2,%2,%4), operands);
!   output_asm_insn (AS2 (mov%B1,%0,%h1), xops);
!   output_asm_insn (AS2 (mov%L4,%4,%3), operands);
!   output_asm_insn (AS1 (fldc%W3,%3), operands);
  
!   if (NON_STACK_REG_P (operands[0]))
!     output_to_reg (operands[0], stack_top_dies);
!   else if (GET_CODE (operands[0]) == MEM)
!     {
!       if (stack_top_dies)
! 	output_asm_insn (AS1 (fistp%z0,%0), operands);
!       else
! 	output_asm_insn (AS1 (fist%z0,%0), operands);
!     }
!   else
!     abort ();
  
!   return AS1 (fldc%W2,%2);
! }
! 
! /* Output code for INSN to compare OPERANDS.  The two operands might
!    not have the same mode: one might be within a FLOAT or FLOAT_EXTEND
!    expression.  If the compare is in mode CCFPEQmode, use an opcode that
!    will not fault if a qNaN is present. */
  
! char *
! output_float_compare (insn, operands)
!      rtx insn;
!      rtx *operands;
! {
!   int stack_top_dies;
!   rtx body = XVECEXP (PATTERN (insn), 0, 0);
!   int unordered_compare = GET_MODE (SET_SRC (body)) == CCFPEQmode;
  
!   /* intel1 */
!   rtx tmp;
!   if (! STACK_TOP_P (operands[0]))
!     {
!       tmp = operands[0];
!       operands[0] = operands[1];
!       operands[1] = tmp;
!       cc_status.flags |= CC_REVERSED;
!     }
!     
!   if (! STACK_TOP_P (operands[0]))
!     abort ();
  
!   stack_top_dies = find_regno_note (insn, REG_DEAD, FIRST_STACK_REG) != 0;
  
!   if (STACK_REG_P (operands[1])
!       && stack_top_dies
!       && find_regno_note (insn, REG_DEAD, REGNO (operands[1]))
!       && REGNO (operands[1]) != FIRST_STACK_REG)
!     {
!       /* If both the top of the 387 stack dies, and the other operand
! 	 is also a stack register that dies, then this must be a
! 	 `fcompp' float compare */
! 
!       if (unordered_compare)
! 	output_asm_insn ("fucompp", operands);
        else
! 	output_asm_insn ("fcompp", operands);
      }
+   else
+     {
+       static char buf[100];
+ 
+       /* Decide if this is the integer or float compare opcode, or the
+ 	 unordered float compare. */
+ 
+       if (unordered_compare)
+ 	strcpy (buf, "fucom");
+       else if (GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_FLOAT)
+ 	strcpy (buf, "fcom");
+       else
+ 	strcpy (buf, "ficom");
+ 
+       /* Modify the opcode if the 387 stack is to be popped. */
+ 
+       if (stack_top_dies)
+ 	strcat (buf, "p");
+ 
+       if (NON_STACK_REG_P (operands[1]))
+ 	output_op_from_reg (operands[1], strcat (buf, AS1 (%z0,%1)));
+       else
+         output_asm_insn (strcat (buf, AS1 (%z1,%y1)), operands);
+     }
+ 
+   /* Now retrieve the condition code. */
+ 
+   return output_fp_cc0_set (insn);
  }
  
! /* Output opcodes to transfer the results of FP compare or test INSN
!    from the FPU to the CPU flags.  If TARGET_IEEE_FP, ensure that if the
!    result of the compare or test is unordered, no comparison operator
!    succeeds except NE.  Return an output template, if any.  */
  
! char *
! output_fp_cc0_set (insn)
!      rtx insn;
! {
!   rtx xops[3];
!   rtx unordered_label;
!   rtx next;
!   enum rtx_code code;
  
!   xops[0] = gen_rtx (REG, HImode, 0);
!   output_asm_insn (AS1 (fnsts%W0,%0), xops);
  
! 
!   if (! TARGET_IEEE_FP)
      {
!       /* intel1 */
!       if (!(cc_status.flags & CC_REVERSED))
!         {
!           next = next_cc0_user (insn);
!         
!           if (GET_CODE (next) == JUMP_INSN
!               && GET_CODE (PATTERN (next)) == SET
!               && SET_DEST (PATTERN (next)) == pc_rtx
!               && GET_CODE (SET_SRC (PATTERN (next))) == IF_THEN_ELSE)
!             {
!               code = GET_CODE (XEXP (SET_SRC (PATTERN (next)), 0));
!             }
!           else if (GET_CODE (PATTERN (next)) == SET)
!             {
!               code = GET_CODE (SET_SRC (PATTERN (next)));
!             }
!           else
!             {
!               return "sahf";
!             }
!           if (code == GT || code == LT || code == EQ || code == NE
!               || code == LE || code == GE)
!             { /* We will test eax directly */
!               cc_status.flags |= CC_TEST_AX;
!               RET;
!             }
!         }
!       return "sahf";
!     }
  
!   next = next_cc0_user (insn);
!   if (next == NULL_RTX)
!     abort ();
  
!   if (GET_CODE (next) == JUMP_INSN
!       && GET_CODE (PATTERN (next)) == SET
!       && SET_DEST (PATTERN (next)) == pc_rtx
!       && GET_CODE (SET_SRC (PATTERN (next))) == IF_THEN_ELSE)
!     {
!       code = GET_CODE (XEXP (SET_SRC (PATTERN (next)), 0));
      }
!   else if (GET_CODE (PATTERN (next)) == SET)
      {
!       code = GET_CODE (SET_SRC (PATTERN (next)));
      }
    else
+     abort ();
+ 
+   xops[0] = gen_rtx (REG, QImode, 0);
+ 
+   switch (code)
      {
!     case GT:
!       xops[1] = GEN_INT (0x45);
!       output_asm_insn (AS2 (and%B0,%1,%h0), xops);
!       /* je label */
!       break;
! 
!     case LT:
!       xops[1] = GEN_INT (0x45);
!       xops[2] = GEN_INT (0x01);
!       output_asm_insn (AS2 (and%B0,%1,%h0), xops);
!       output_asm_insn (AS2 (cmp%B0,%2,%h0), xops);
!       /* je label */
!       break;
! 
!     case GE:
!       xops[1] = GEN_INT (0x05);
!       output_asm_insn (AS2 (and%B0,%1,%h0), xops);
!       /* je label */
!       break;
! 
!     case LE:
!       xops[1] = GEN_INT (0x45);
!       xops[2] = GEN_INT (0x40);
!       output_asm_insn (AS2 (and%B0,%1,%h0), xops);
!       output_asm_insn (AS1 (dec%B0,%h0), xops);
!       output_asm_insn (AS2 (cmp%B0,%2,%h0), xops);
!       /* jb label */
!       break;
! 
!     case EQ:
!       xops[1] = GEN_INT (0x45);
!       xops[2] = GEN_INT (0x40);
!       output_asm_insn (AS2 (and%B0,%1,%h0), xops);
!       output_asm_insn (AS2 (cmp%B0,%2,%h0), xops);
!       /* je label */
!       break;
! 
!     case NE:
!       xops[1] = GEN_INT (0x44);
!       xops[2] = GEN_INT (0x40);
!       output_asm_insn (AS2 (and%B0,%1,%h0), xops);
!       output_asm_insn (AS2 (xor%B0,%2,%h0), xops);
!       /* jne label */
!       break;
! 
!     case GTU:
!     case LTU:
!     case GEU:
!     case LEU:
!     default:
!       abort ();
      }
+   RET;
+ }
+ 
+ #define MAX_386_STACK_LOCALS 2
+ 
+ static rtx i386_stack_locals[(int) MAX_MACHINE_MODE][MAX_386_STACK_LOCALS];
+ 
+ /* Define the structure for the machine field in struct function.  */
+ struct machine_function
+ {
+   rtx i386_stack_locals[(int) MAX_MACHINE_MODE][MAX_386_STACK_LOCALS];
+ };
+ 
+ /* Functions to save and restore i386_stack_locals.
+    These will be called, via pointer variables,
+    from push_function_context and pop_function_context.  */
+ 
+ void
+ save_386_machine_status (p)
+      struct function *p;
+ {
+   p->machine = (struct machine_function *) xmalloc (sizeof i386_stack_locals);
+   bcopy (i386_stack_locals, p->machine->i386_stack_locals,
+ 	 sizeof i386_stack_locals);
  }
  
  void
! restore_386_machine_status (p)
!      struct function *p;
  {
!   bcopy (p->machine->i386_stack_locals, i386_stack_locals,
! 	 sizeof i386_stack_locals);
!   free (p->machine);
  }
  
! /* Clear stack slot assignments remembered from previous functions.
!    This is called from INIT_EXPANDERS once before RTL is emitted for each
!    function.  */
! 
! void
! clear_386_stack_locals ()
  {
!   enum machine_mode mode;
!   int n;
  
!   for (mode = VOIDmode; (int) mode < (int) MAX_MACHINE_MODE;
!        mode = (enum machine_mode) ((int) mode + 1))
!     for (n = 0; n < MAX_386_STACK_LOCALS; n++)
!       i386_stack_locals[(int) mode][n] = NULL_RTX;
  
!   /* Arrange to save and restore i386_stack_locals around nested functions.  */
!   save_machine_status = save_386_machine_status;
!   restore_machine_status = restore_386_machine_status;
  }
  
! /* Return a MEM corresponding to a stack slot with mode MODE.
!    Allocate a new slot if necessary.
  
!    The RTL for a function can have several slots available: N is
!    which slot to use.  */
! 
! rtx
! assign_386_stack_local (mode, n)
!      enum machine_mode mode;
!      int n;
  {
!   if (n < 0 || n >= MAX_386_STACK_LOCALS)
!     abort ();
  
!   if (i386_stack_locals[(int) mode][n] == NULL_RTX)
!   {
!     i386_stack_locals[(int) mode][n]
!       = assign_stack_local (mode, GET_MODE_SIZE (mode), 0);
!   }
!   return i386_stack_locals[(int) mode][n];
! }
  
  
! /* all functions after here added by intel1 */
! /* intel1 */
! int is_mul(op,mode)
!     register rtx op;
!     enum machine_mode mode;
! {
!   return(GET_CODE(op)==MULT);
  }
  
! /* intel1 */
! int is_div(op,mode)
      register rtx op;
      enum machine_mode mode;
  {
!   return(GET_CODE(op)==DIV);
  }
  
! /* Create a new copy of an rtx.
!    Recursively copies the operands of the rtx,
!    except for those few rtx codes that are sharable.
!    Doesn't share CONST  */
  
! rtx
! copy_all_rtx (orig)
!      register rtx orig;
  {
!   register rtx copy;
!   register int i, j;
!   register RTX_CODE code;
!   register char *format_ptr;
  
!   code = GET_CODE (orig);
! 
!   switch (code)
      {
!     case REG:
!     case QUEUED:
!     case CONST_INT:
!     case CONST_DOUBLE:
!     case SYMBOL_REF:
!     case CODE_LABEL:
!     case PC:
!     case CC0:
!     case SCRATCH:
!       /* SCRATCH must be shared because they represent distinct values. */
!       return orig;
  
! #if 0
!     case CONST:
!       /* CONST can be shared if it contains a SYMBOL_REF.  If it contains
! 	 a LABEL_REF, it isn't sharable.  */
!       if (GET_CODE (XEXP (orig, 0)) == PLUS
! 	  && GET_CODE (XEXP (XEXP (orig, 0), 0)) == SYMBOL_REF
! 	  && GET_CODE (XEXP (XEXP (orig, 0), 1)) == CONST_INT)
! 	return orig;
        break;
+ #endif
+       /* A MEM with a constant address is not sharable.  The problem is that
+ 	 the constant address may need to be reloaded.  If the mem is shared,
+ 	 then reloading one copy of this mem will cause all copies to appear
+ 	 to have been reloaded.  */
+     }
+ 
+   copy = rtx_alloc (code);
+   PUT_MODE (copy, GET_MODE (orig));
+   copy->in_struct = orig->in_struct;
+   copy->volatil = orig->volatil;
+   copy->unchanging = orig->unchanging;
+   copy->integrated = orig->integrated;
+   /* intel1 */
+   copy->is_spill_rtx = orig->is_spill_rtx;
+   
+   format_ptr = GET_RTX_FORMAT (GET_CODE (copy));
+ 
+   for (i = 0; i < GET_RTX_LENGTH (GET_CODE (copy)); i++)
+     {
+       switch (*format_ptr++)
+ 	{
+ 	case 'e':
+ 	  XEXP (copy, i) = XEXP (orig, i);
+ 	  if (XEXP (orig, i) != NULL)
+ 	    XEXP (copy, i) = copy_rtx (XEXP (orig, i));
+ 	  break;
  
! 	case '0':
! 	case 'u':
! 	  XEXP (copy, i) = XEXP (orig, i);
! 	  break;
  
! 	case 'E':
! 	case 'V':
! 	  XVEC (copy, i) = XVEC (orig, i);
! 	  if (XVEC (orig, i) != NULL)
! 	    {
! 	      XVEC (copy, i) = rtvec_alloc (XVECLEN (orig, i));
! 	      for (j = 0; j < XVECLEN (copy, i); j++)
! 		XVECEXP (copy, i, j) = copy_rtx (XVECEXP (orig, i, j));
! 	    }
! 	  break;
  
! 	case 'w':
! 	  XWINT (copy, i) = XWINT (orig, i);
! 	  break;
! 
! 	case 'i':
! 	  XINT (copy, i) = XINT (orig, i);
! 	  break;
! 
! 	case 's':
! 	case 'S':
! 	  XSTR (copy, i) = XSTR (orig, i);
! 	  break;
! 
! 	default:
! 	  abort ();
! 	}
!     }
!   return copy;
! }
! 
! 
! /* try to rewrite a memory address to make it valid */
! void 
! rewrite_address (mem_rtx)
!      rtx mem_rtx;
! {
!   rtx index_rtx, base_rtx, offset_rtx, scale_rtx, ret_rtx;
!   int scale = 1;
!   int offset_adjust = 0;
!   int was_only_offset = 0;
!   rtx mem_addr = XEXP (mem_rtx, 0);
!   char *storage = (char *) oballoc (0);
!   int in_struct = 0;
!   int is_spill_rtx = 0;
! 
!   in_struct = MEM_IN_STRUCT_P (mem_rtx);
!   is_spill_rtx = RTX_IS_SPILL_P (mem_rtx);
! 
!   if (GET_CODE (mem_addr) == PLUS &&
!       GET_CODE (XEXP (mem_addr, 1)) == PLUS &&
!       GET_CODE (XEXP (XEXP (mem_addr, 1), 0)) == REG)
!     {				/* this part is utilized by the combiner */
!       ret_rtx =
! 	gen_rtx (PLUS, GET_MODE (mem_addr),
! 		 gen_rtx (PLUS, GET_MODE (XEXP (mem_addr, 1)),
! 			  XEXP (mem_addr, 0),
! 			  XEXP (XEXP (mem_addr, 1), 0)),
! 		 XEXP (XEXP (mem_addr, 1), 1));
!       if (memory_address_p (GET_MODE (mem_rtx), ret_rtx))
! 	{
! 	  XEXP (mem_rtx, 0) = ret_rtx;
! 	  RTX_IS_SPILL_P (ret_rtx) = is_spill_rtx;
! 	  return;
! 	}
!       obfree (storage);
!     }
! 
!   /* this part is utilized by loop.c */
!   /* If the address contains PLUS (reg,const) and this pattern is invalid
!      in this case - try to rewrite the address to make it valid  intel1
!   */
!   storage = (char *) oballoc (0);
!   index_rtx = base_rtx = offset_rtx = NULL;
!   /* find the base index and offset elements of the memory address */
!   if (GET_CODE (mem_addr) == PLUS)
!     {
!       if (GET_CODE (XEXP (mem_addr, 0)) == REG)
! 	{
! 	  if (GET_CODE (XEXP (mem_addr, 1)) == REG)
! 	    {
! 	      base_rtx = XEXP (mem_addr, 1);
! 	      index_rtx = XEXP (mem_addr, 0);
! 	    }
! 	  else
! 	    {
! 	      base_rtx = XEXP (mem_addr, 0);
! 	      offset_rtx = XEXP (mem_addr, 1);
! 	    }
! 	}
!       else if (GET_CODE (XEXP (mem_addr, 0)) == MULT)
! 	{
! 	  index_rtx = XEXP (mem_addr, 0);
! 	  if (GET_CODE (XEXP (mem_addr, 1)) == REG)
! 	    {
! 	      base_rtx = XEXP (mem_addr, 1);
! 	    }
! 	  else
! 	    {
! 	      offset_rtx = XEXP (mem_addr, 1);
! 	    }
! 	}
!       else if (GET_CODE (XEXP (mem_addr, 0)) == PLUS)
! 	{
! 	  /* intel1 */
! 	  if (GET_CODE (XEXP (XEXP (mem_addr, 0), 0)) == PLUS &&
! 	      GET_CODE (XEXP (XEXP (XEXP (mem_addr, 0), 0), 0)) == MULT &&
! 	      GET_CODE (XEXP (XEXP (XEXP (XEXP (mem_addr, 0), 0), 0), 0)) == REG &&
! 	      GET_CODE (XEXP (XEXP (XEXP (XEXP (mem_addr, 0), 0), 0), 1)) == CONST_INT &&
! 	      GET_CODE (XEXP (XEXP (XEXP (mem_addr, 0), 0), 1)) == CONST_INT &&
! 	      GET_CODE (XEXP (XEXP (mem_addr, 0), 1)) == REG &&
! 	      GET_CODE (XEXP (mem_addr, 1)) == SYMBOL_REF)
! 	    {
! 	      index_rtx = XEXP (XEXP (XEXP (mem_addr, 0), 0), 0);
! 	      offset_rtx = XEXP (mem_addr, 1);
! 	      base_rtx = XEXP (XEXP (mem_addr, 0), 1);
! 	      offset_adjust = INTVAL (XEXP (XEXP (XEXP (mem_addr, 0), 0), 1));
! 	    }
! 	  else
! 	    {
! 	      offset_rtx = XEXP (mem_addr, 1);
! 	      index_rtx = XEXP (XEXP (mem_addr, 0), 0);
! 	      base_rtx = XEXP (XEXP (mem_addr, 0), 1);
! 	    }
! 	}
!       else if (GET_CODE (XEXP (mem_addr, 0)) == CONST_INT)
! 	{
! 	  was_only_offset = 1;
! 	  index_rtx = NULL;
! 	  base_rtx = NULL;
! 	  offset_rtx = XEXP (mem_addr, 1);
! 	  offset_adjust = INTVAL (XEXP (mem_addr, 0));
! 	  if (offset_adjust == 0)
! 	    {
! 	      XEXP (mem_rtx, 0) = offset_rtx;
! 	      RTX_IS_SPILL_P (XEXP (mem_rtx, 0)) = is_spill_rtx;
! 	      return;
! 	    }
! 	}
!       else
! 	{
! 	  obfree (storage);
! 	  return;
! 	}
!     }
!   else if (GET_CODE (mem_addr) == MULT)
!     {
!       index_rtx = mem_addr;
!     }
!   else
!     {
!       obfree (storage);
!       return;
!     }
!   if (index_rtx && GET_CODE (index_rtx) == MULT)
!     {
!       if (GET_CODE (XEXP (index_rtx, 1)) != CONST_INT)
! 	{
! 	  obfree (storage);
! 	  return;
! 	}
!       scale_rtx = XEXP (index_rtx, 1);
!       scale = INTVAL (scale_rtx);
!       index_rtx = copy_all_rtx (XEXP (index_rtx, 0));
!     }
!   /* now find which of the elements are invalid and try to fix them */
!   if (index_rtx && GET_CODE (index_rtx) == CONST_INT && base_rtx == NULL)
!     {
!       offset_adjust = INTVAL (index_rtx) * scale;
!       if (offset_rtx && GET_CODE (offset_rtx) == CONST &&
! 	  GET_CODE (XEXP (offset_rtx, 0)) == PLUS)
! 	{
! 	  if (GET_CODE (XEXP (XEXP (offset_rtx, 0), 0)) == SYMBOL_REF &&
! 	      GET_CODE (XEXP (XEXP (offset_rtx, 0), 1)) == CONST_INT)
! 	    {
! 	      offset_rtx = copy_all_rtx (offset_rtx);
! 	      XEXP (XEXP (offset_rtx, 0), 1) =
! 		gen_rtx (CONST_INT, 0, INTVAL (XEXP (XEXP (offset_rtx, 0), 1)) + offset_adjust);
! 	      if (!CONSTANT_P (offset_rtx))
! 		{
! 		  obfree (storage);
! 		  return;
! 		}
! 	    }
! 	}
!       else if (offset_rtx && GET_CODE (offset_rtx) == SYMBOL_REF)
! 	{
! 	  offset_rtx =
! 	    gen_rtx (CONST, GET_MODE (offset_rtx),
! 		     gen_rtx (PLUS, GET_MODE (offset_rtx),
! 			      offset_rtx,
! 			      gen_rtx (CONST_INT, 0, offset_adjust)));
! 	  if (!CONSTANT_P (offset_rtx))
! 	    {
! 	      obfree (storage);
! 	      return;
! 	    }
! 	}
!       else if (offset_rtx && GET_CODE (offset_rtx) == CONST_INT)
! 	{
! 	  offset_rtx = gen_rtx (CONST_INT, 0, INTVAL (offset_rtx) + offset_adjust);
! 	}
!       else if (!offset_rtx)
! 	{
! 	  offset_rtx = gen_rtx (CONST_INT, 0, 0);
! 	}
!       RTX_IS_SPILL_P (XEXP (mem_rtx, 0)) = is_spill_rtx;
!       XEXP (mem_rtx, 0) = offset_rtx;
!       return;
      }
!   if (base_rtx && GET_CODE (base_rtx) == PLUS &&
!       GET_CODE (XEXP (base_rtx, 0)) == REG &&
!       GET_CODE (XEXP (base_rtx, 1)) == CONST_INT)
      {
!       offset_adjust += INTVAL (XEXP (base_rtx, 1));
!       base_rtx = copy_all_rtx (XEXP (base_rtx, 0));
!     }
!   else if (base_rtx && GET_CODE (base_rtx) == CONST_INT)
!     {
!       offset_adjust += INTVAL (base_rtx);
!       base_rtx = NULL;
!     }
!   if (index_rtx && GET_CODE (index_rtx) == PLUS &&
!       GET_CODE (XEXP (index_rtx, 0)) == REG &&
!       GET_CODE (XEXP (index_rtx, 1)) == CONST_INT)
!     {
!       offset_adjust += INTVAL (XEXP (index_rtx, 1)) * scale;
!       index_rtx = copy_all_rtx (XEXP (index_rtx, 0));
!     }
!   if (index_rtx)
!     {
!       if (!LEGITIMATE_INDEX_P (index_rtx)
!       && !(index_rtx == stack_pointer_rtx && scale == 1 && base_rtx == NULL))
  	{
! 	  obfree (storage);
! 	  return;
  	}
!     }
!   if (base_rtx)
!     {
!       if (!LEGITIMATE_INDEX_P (base_rtx) && GET_CODE (base_rtx) != REG)
  	{
! 	  obfree (storage);
! 	  return;
  	}
!     }
!   if (offset_adjust != 0)
!     {
!       if (offset_rtx)
  	{
! 	  if (GET_CODE (offset_rtx) == CONST &&
! 	      GET_CODE (XEXP (offset_rtx, 0)) == PLUS)
! 	    {
! 	      if (GET_CODE (XEXP (XEXP (offset_rtx, 0), 0)) == SYMBOL_REF &&
! 		  GET_CODE (XEXP (XEXP (offset_rtx, 0), 1)) == CONST_INT)
! 		{
! 		  offset_rtx = copy_all_rtx (offset_rtx);
! 		  XEXP (XEXP (offset_rtx, 0), 1) =
! 		    gen_rtx (CONST_INT, 0, INTVAL (XEXP (XEXP (offset_rtx, 0), 1)) + offset_adjust);
! 		  if (!CONSTANT_P (offset_rtx))
! 		    {
! 		      obfree (storage);
! 		      return;
! 		    }
! 		}
! 	    }
! 	  else if (GET_CODE (offset_rtx) == SYMBOL_REF)
! 	    {
! 	      offset_rtx =
! 		gen_rtx (CONST, GET_MODE (offset_rtx),
! 			 gen_rtx (PLUS, GET_MODE (offset_rtx),
! 				  offset_rtx,
! 				  gen_rtx (CONST_INT, 0, offset_adjust)));
! 	      if (!CONSTANT_P (offset_rtx))
! 		{
! 		  obfree (storage);
! 		  return;
! 		}
! 	    }
! 	  else if (GET_CODE (offset_rtx) == CONST_INT)
! 	    {
! 	      offset_rtx = gen_rtx (CONST_INT, 0, INTVAL (offset_rtx) + offset_adjust);
! 	    }
! 	  else
! 	    {
! 	      obfree (storage);
! 	      return;
! 	    }
  	}
        else
  	{
! 	  offset_rtx = gen_rtx (CONST_INT, 0, offset_adjust);
  	}
!       if (index_rtx)
  	{
! 	  if (base_rtx)
! 	    {
! 	      if (scale != 1)
! 		{
! 		  if (GET_CODE (offset_rtx) == CONST_INT &&
! 		      INTVAL (offset_rtx) == 0)
! 		    {
! 		      ret_rtx = gen_rtx (PLUS, GET_MODE (base_rtx),
! 			     gen_rtx (MULT, GET_MODE (index_rtx), index_rtx,
! 				      scale_rtx),
! 					 base_rtx);
! 		    }
! 		  else
! 		    {
! 		      ret_rtx = gen_rtx (PLUS, GET_MODE (offset_rtx),
! 					 gen_rtx (PLUS, GET_MODE (base_rtx),
! 			     gen_rtx (MULT, GET_MODE (index_rtx), index_rtx,
! 				      scale_rtx),
! 						  base_rtx),
! 					 offset_rtx);
! 		    }
! 		}
! 	      else
! 		{
! 		  if (GET_CODE (offset_rtx) == CONST_INT &&
! 		      INTVAL (offset_rtx) == 0)
! 		    {
! 		      ret_rtx = gen_rtx (PLUS, GET_MODE (index_rtx), index_rtx, base_rtx);
! 		    }
! 		  else
! 		    {
! 		      ret_rtx = gen_rtx (PLUS, GET_MODE (offset_rtx),
! 			     gen_rtx (PLUS, GET_MODE (index_rtx), index_rtx,
! 				      base_rtx),
! 					 offset_rtx);
! 		    }
! 		}
! 	    }
! 	  else
! 	    {
! 	      if (scale != 1)
! 		{
! 		  if (GET_CODE (offset_rtx) == CONST_INT &&
! 		      INTVAL (offset_rtx) == 0)
! 		    {
! 		      ret_rtx = gen_rtx (MULT, GET_MODE (index_rtx), index_rtx, scale_rtx);
! 		    }
! 		  else
! 		    {
! 		      ret_rtx =
! 			gen_rtx (PLUS, GET_MODE (offset_rtx),
! 			     gen_rtx (MULT, GET_MODE (index_rtx), index_rtx,
! 				      scale_rtx),
! 				 offset_rtx);
! 		    }
! 		}
! 	      else
! 		{
! 		  if (GET_CODE (offset_rtx) == CONST_INT &&
! 		      INTVAL (offset_rtx) == 0)
! 		    {
! 		      ret_rtx = index_rtx;
! 		    }
! 		  else
! 		    {
! 		      ret_rtx = gen_rtx (PLUS, GET_MODE (index_rtx), index_rtx, offset_rtx);
! 		    }
! 		}
! 	    }
  	}
!       else
  	{
! 	  if (base_rtx)
! 	    {
! 	      if (GET_CODE (offset_rtx) == CONST_INT &&
! 		  INTVAL (offset_rtx) == 0)
! 		{
! 		  ret_rtx = base_rtx;
! 		}
! 	      else
! 		{
! 		  ret_rtx = gen_rtx (PLUS, GET_MODE (base_rtx), base_rtx, offset_rtx);
! 		}
! 	    }
! 	  else if (was_only_offset)
! 	    {
! 	      ret_rtx = offset_rtx;
! 	    }
  	  else
! 	    {
! 	      obfree (storage);
! 	      return;
! 	    }
  	}
!       XEXP (mem_rtx, 0) = ret_rtx;
!       RTX_IS_SPILL_P (XEXP (mem_rtx, 0)) = is_spill_rtx;
!       return;
!     }
!   else
!     {
!       obfree (storage);
!       return;
      }
  }
  
! /* return 1 if the first insn to set cc before insn also sets the register
!    reg_rtx - otherwise return 0
! */
! int
! last_to_set_cc (reg_rtx, insn)
!      rtx reg_rtx, insn;
  {
!   rtx prev_insn = PREV_INSN (insn);
  
!   while (prev_insn)
      {
!       if (GET_CODE (prev_insn) == NOTE)
! 	{
! 	  ;
! 	}
!       else if (GET_CODE (prev_insn) == INSN)
! 	{
! 	  if (GET_CODE (PATTERN (prev_insn)) != SET)
! 	    {
! 	      return (0);
! 	    }
! 	  if (rtx_equal_p (SET_DEST (PATTERN (prev_insn)), reg_rtx))
! 	    {
! 	      if (sets_condition_code (SET_SRC (PATTERN (prev_insn))))
! 		{
! 		  return (1);
! 		}
! 	      else
! 		{
! 		  return (0);
! 		}
! 	    }
! 	  else if (!doesnt_set_condition_code (SET_SRC (PATTERN (prev_insn))))
! 	    {
! 	      return (0);
! 	    }
! 	}
        else
! 	{
! 	  return (0);
! 	}
!       prev_insn = PREV_INSN (prev_insn);
      }
!   return (0);
  }
  
! int
! doesnt_set_condition_code (pat)
!      rtx pat;
  {
!   switch (GET_CODE (pat))
      {
!     case MEM:
!     case REG:
!       return (1);
  
!     default:
!       return (0);
  
!     }
  }
  
! int
! sets_condition_code (pat)
!      rtx pat;
  {
!   switch (GET_CODE (pat))
!     {
!     case PLUS:
!     case MINUS:
!     case AND:
!     case IOR:
!     case XOR:
!     case NOT:
!     case NEG:
!     case MULT:
!     case DIV:
!     case MOD:
!     case UDIV:
!     case UMOD:
!       return (1);
  
!     default:
!       return (0);
  
!     }
! }
  
  
! /* intel1 */
! int
! str_immediate_operand (op, mode)
!      register rtx op;
!      enum machine_mode mode;
! {
!   if (GET_CODE (op) == CONST_INT && INTVAL (op) <= 32 && INTVAL (op) >= 0)
      {
!       return (1);
      }
!   return (0);
! }
  
! /* intel1 */
! void
! override_options ()
! {
!   register int i, start;
!   register int regno;
!   register enum machine_mode mode;
!   char *p;
! #if 0
!   int blend = 0;
! #endif
  
!   /* only one `-mcpu' allowed */
!   if (TARGET_X && (TARGET_X != TARGET_386) && (TARGET_X != TARGET_486) && (TARGET_X != TARGET_PENTIUM))
!     fatal ("multilple `-mcpu' definitions .\n");
! 
!  /* if `-mcpu' use it, otherwise take default */
!  target_flags |= USE_CPU;
! 
!   if (TARGET_PENTIUM)
!     x86_cpu = PROCESSOR_PENTIUM;
!   else if (TARGET_486)
!     x86_cpu = PROCESSOR_486;
!   else if (TARGET_386)
!     x86_cpu = PROCESSOR_386;
!   else /* no processor type ? */
!     fatal ("no processor type.\n");
!   
! #if 0 /* what happens if we have few -mcpu's, I don't think it's needed */
!   /* Identify the processor type */
!   if (!(TARGET_PENTIUM) && !(TARGET_486) && !(TARGET_386))
!     {
!       x86_cpu = PROCESSOR_PENTIUM;
!       target_flags |= (TARGET_486_SWITCH);
!       blend = 1;
!     }
! 
!   else
      {
!       x86_cpu = PROCESSOR_DEFAULT;
!       if (TARGET_PENTIUM)
! 	{
! 	  x86_cpu = PROCESSOR_PENTIUM;
! 	}
!       if (TARGET_486)
! 	{
! 	  if (x86_cpu != PROCESSOR_DEFAULT)
! 	    {
! 	      error ("conflicting -mX86 : using blend");
! 	      blend = 1;
! 	      x86_cpu = PROCESSOR_PENTIUM;
! 	      target_flags &= ~(TARGET_386_SWITCH);
! 	      target_flags &= ~(TARGET_PENTIUM_SWITCH);
! 	    }
! 	  else
! 	    {
! 	      x86_cpu = PROCESSOR_486;
! 	    }
! 	}
!       if (TARGET_386)
! 	{
! 	  if (x86_cpu != PROCESSOR_DEFAULT)
! 	    {
! 	      error ("conflicting -mX86 : using blend");
! 	      blend = 1;
! 	      x86_cpu = PROCESSOR_486;
! 	      target_flags &= ~(TARGET_386_SWITCH);
! 	      target_flags &= ~(TARGET_PENTIUM_SWITCH);
! 	      target_flags |= (TARGET_486_SWITCH);
! 	    }
! 	  else
! 	    {
! 	      x86_cpu = PROCESSOR_386;
! 	    }
! 	}
  
  
!     }
! #endif
!   if (opt_level >= 4)
!     {
!       if (TARGET_486)
!         {
! 	  if (opt_level == 4
! 	      && !flag_no_interleave_stack_non_stack)
! 	    {
! 	      flag_interleave_stack_non_stack = 1;
! 	      flag_schedule_insns = 1;
! 	    }
!         }
! #if 0
!       if(TARGET_BLEND)
!         {
!           if (!flag_no_risc)
!             flag_risc = 1;
!           if (!flag_no_risc_const)
!             flag_risc_const = 1;
!           if (!flag_no_recombine)
!             flag_recombine = 1;
!         }
! #endif
!       if (TARGET_PENTIUM)
!         {
!           if (!flag_no_risc)
!             flag_risc = 1;
!           if (!flag_no_risc_const)
!             flag_risc_const = 1;
!           /*if (!flag_no_recombine)
!             flag_recombine = 1;*/
! 	  if (opt_level == 4
! 	      && !flag_no_schedule_stack_reg_insns)
! 	    {
! 	      flag_schedule_stack_reg_insns = 1;
! 	      flag_schedule_insns = 1;
! 	    }
! 	  if (opt_level == 4
! 	      && !flag_no_interleave_stack_non_stack)
! 	    {
! 	      flag_interleave_stack_non_stack = 1;
! 	      flag_schedule_insns = 1;
! 	    }
!         }
!     }
! }
  
  
  
  
! optimization_options (level)
!      int level;
! {
!   opt_level = level;
!   if (level > 0)
!     {
!       flag_opt_reg_use = 1;
!       flag_reduce_index_givs = 1;
      }
!   if (level >= 2)
!     {
! #ifdef INSN_SCHEDULING
!       flag_schedule_insns = 0;
!       flag_schedule_insns_after_reload = 0;
! #endif
!     }
!   if (level >= 3)
!     {
!       flag_inline_functions = 1;
!       flag_jump_back = 1;
!       flag_copy_prop = 1;
!       flag_compare_elim = 1;
!       flag_sftwr_pipe = 1;
!       flag_omit_frame_pointer = 1;
! 	  /*flag_reg_reg_copy_opt = 1; */
!       flag_opt_reg_stack = 1;
! 	  /*flag_loop_after_global = 1; */
!       flag_peep_spills = 1;
!       flag_replace_stack_mem = 1;
!       flag_opt_jumps_out = 1;
!       flag_replace_mem = 1;
!       flag_correct_cse_mistakes = 1;
!       flag_push_load_into_loop = 1;
!       flag_replace_reload_regs = 1;
!       flag_sign_extension_elim = 1;
!       flag_lift_stores = 1;
!       flag_runtime_lift_stores = 1;
!     }
!   if (level >= 4)
!     {
! #ifdef INSN_SCHEDULING
!       flag_schedule_insns_after_reload = 1;
!       flag_swap_for_agi = 1;
!       if (TARGET_PENTIUM)
! 	{
! 		  /*flag_risc = 1; */
! 	  flag_risc_const = 1;
! 	  /*flag_recombine = 1;*/
! 	  if (level == 4)
! 	    {
! 	      flag_schedule_stack_reg_insns = 1;
! 	      flag_schedule_insns = 1;
! 	    }
! 	}
! #endif
!     }
!   if (level >= 5)
!     {
! #ifdef INSN_SCHEDULING
!       flag_schedule_insns = 1;
! #endif
!     }
!   if (flag_no_risc)
!     flag_risc = 0;
!   if (flag_no_risc_const)
!     flag_risc_const = 0;
!   if (flag_no_recombine)
!     flag_recombine = 0;
!   if (flag_no_risc_mem_dest)
!     flag_risc_mem_dest = 0;
  }
  
! /* intel1 */
  
! int
! is_fp_insn (insn)
!      rtx insn;
  {
!   if (GET_CODE (insn) == INSN && GET_CODE (PATTERN (insn)) == SET
!       && (GET_MODE (SET_DEST (PATTERN (insn))) == DFmode
! 	  || GET_MODE (SET_DEST (PATTERN (insn))) == SFmode))
!     {
!       return (1);
!     }
!   return (0);
! }
  
  
! /*
!   Return 1 if the mode of the SET_DEST of insn is floating point
!   and it is not an fld or a move from memory to memory.
!   Otherwise return 0
! */
! int
! is_fp_dest (insn)
!      rtx insn;
  {
!   if (GET_CODE (insn) == INSN && GET_CODE (PATTERN (insn)) == SET
!       && (GET_MODE (SET_DEST (PATTERN (insn))) == DFmode
! 	  || GET_MODE (SET_DEST (PATTERN (insn))) == SFmode)
!       && GET_CODE (SET_DEST (PATTERN (insn))) == REG
!       && REGNO (SET_DEST (PATTERN (insn))) >= FIRST_FLOAT_REG
!       && GET_CODE (SET_SRC (insn)) != MEM
!      )
!     {
!       return (1);
!     }
!   return (0);
  }
  
! /*
!   Return 1 if the mode of the SET_DEST floating point and is memory
!   and the source is a register.  
! */
! int
! is_fp_store (insn)
!      rtx insn;
  {
!   if (GET_CODE (insn) == INSN && GET_CODE (PATTERN (insn)) == SET
!       && (GET_MODE (SET_DEST (PATTERN (insn))) == DFmode
! 	  || GET_MODE (SET_DEST (PATTERN (insn))) == SFmode)
!       && GET_CODE (SET_DEST (PATTERN (insn))) == MEM
!       && GET_CODE (SET_SRC (PATTERN (insn))) == REG
!      )
!     {
!       return (1);
!     }
!   return (0);
  }
  
  
! /*
!   Return 1 if dep_insn sets a register which insn uses as a base
!   or index to reference memory.
!   otherwise return 0
! */
! int
! agi_dependent (insn, dep_insn)
!      rtx insn, dep_insn;
  {
!   if (GET_CODE (dep_insn) == INSN && GET_CODE (PATTERN (dep_insn)) == SET
!       && GET_CODE (SET_DEST (PATTERN (dep_insn))) == REG)
!     {
!       return (reg_mentioned_in_mem (SET_DEST (PATTERN (dep_insn)), insn));
!     }
!   if (GET_CODE (dep_insn) == INSN && GET_CODE (PATTERN (dep_insn)) == SET
!       && GET_CODE (SET_DEST (PATTERN (dep_insn))) == MEM
!       && push_operand (SET_DEST (PATTERN (dep_insn)),
!                        GET_MODE (SET_DEST (PATTERN (dep_insn))))
!      )
!     {
!       return (reg_mentioned_in_mem (stack_pointer_rtx, insn));
!     }
!   
!   return (0);
! }
  
! /*
!   Return 1 if reg is used in rtl as a base or index for a memory ref
!   otherwise return 0.
! */
! int
! reg_mentioned_in_mem (reg, rtl)
!      rtx reg, rtl;
! {
!   register char *fmt;
!   register int i;
!   register enum rtx_code code;
  
!   if (rtl == NULL)
!     return (0);
  
!   code = GET_CODE (rtl);
  
!   switch (code)
!     {
!     case HIGH:
!     case CONST_INT:
!     case CONST:
!     case CONST_DOUBLE:
!     case SYMBOL_REF:
!     case LABEL_REF:
!     case PC:
!     case CC0:
!     case SUBREG:
!       return (0);
  
  
!     }
  
!   if (code == MEM && reg_mentioned_p (reg, rtl))
!     {
!       return (1);
!     }
! 
!   fmt = GET_RTX_FORMAT (code);
! 
!   for (i = GET_RTX_LENGTH (code) - 1; i >= 0; i--)
!     {
!       if (fmt[i] == 'E')
! 	{
! 	  register int j;
! 	  for (j = XVECLEN (rtl, i) - 1; j >= 0; j--)
! 	    if (reg_mentioned_in_mem (reg, XVECEXP (rtl, i, j)))
! 	      return 1;
! 	}
!       else if (fmt[i] == 'e'
! 	       && reg_mentioned_in_mem (reg, XEXP (rtl, i)))
! 	return 1;
!     }
!   return (0);
  }
+ 
